/*----------------------------------------------------------*/
/*                                                          */
/*   Turbo Vision 1.0                                       */
/*   Copyright (c) 1991 by Borland International            */
/*                                                          */
/*   Turbo Vision TVEDIT header file                        */
/*----------------------------------------------------------*/
class TMenuBar;
class TStatusLine;
class TEditWindow;
class TDialog;
class Formula;
class EditWindow;
class EditWindow1;

const
	cmOpen       = 100,
	cmNew        = 101,
	cmChangeDrct = 102,
	cmDosShell   = 103,
	cmCalculator = 104,
	cmShowClip   = 105,
	cmRetrieve   = 106,
	cmNewProt    = 108,
	cmRefresh    = 109,
	cmFormat     = 110,
	cmDNF        = 114,
	cmCNF        = 115,
	cmCon        = 116,
	cmDis        = 117,
	cmConDis     = 118,
	cmImp        = 119,
	cmCompile    = 120,
	cmDecompile  = 121,
	cmDecision   = 122,
	cmEval       = 123,
	cmMinimalDNF = 124,
	cmMinimalCNF = 125,
	cmContents   = 126,
	cmAbout      = 127,
	cmSystem     = 128,
	cmPL         = 129,
	edOK         = 20000,
	edNothing    = 20001,
	edillchar    = 20002,
	edmissoper   = 20003,
	edmissexp    = 20004,
	edmissbra    = 20005,
	edunexpbra   = 20006,
	edinsertfail = 20007,
	ending='\0',
	andchar='&',
	orchar='|';
 /*	TIgnored={'\1'..'\32'},
		TLegal=['a'..'z','A'..'Z','0','1',ending,'&','|','~','>',
													'=','(',')' ]*/

struct TreeNode
{
	char character;
	short prior,neg;
	TreeNode *left,*right;
};

struct StackNode
{
	TreeNode *node;
	StackNode *next;
};

enum ErrorType {OK,illchar,missoper,missexp,missbra,unexpbra,endcomp,
								insfail,mem} error;

typedef StackNode *PStack;
typedef TreeNode *PTreeNode;
typedef StackNode *PStackNode;
PStack Stack;
const sig=3;

struct Format
{
		ushort checkBoxData;
		ushort radioButtonData;
};

class EditWindow1: public TEditWindow
{
	public:
	Formula *F;
	Format Ft;
	ErrorType Error;
	EditWindow1(const TRect&,const char*,int);
	virtual ~EditWindow1();
	virtual void handleEvent(TEvent &Event);
	void XComp();
	void XDecomp();
	void InsertCharacter(char);
	void InsertLine();
	void InsertString(char*);
	void InsertFail();
	void Dive(PTreeNode&);
	void DoDialog();
	void Decision();
	void GetChar();
	void Exp1();
	void Exp2();
	void Exp3();
	void Exp4();
	void ICE();
};

struct DialogData
{
	unsigned RBData1,RBData2,RBData3;
	char	InputLineData[4];
};

class Formula
{
	public:
	PTreeNode Stree;
	EditWindow1 *Protocol;
	Formula();
	virtual ~Formula();
	void DisposeTree();
	void CopyTree(PTreeNode&);
	void ConstEval();
	void ToImp();
	void ToDis();
	void ToCon();
	void ToConDis();
	void ToCNF();
	void ToDNF();
	void RDisposeTree(PTreeNode&);
	void RCopyTree(PTreeNode&,PTreeNode&);
	void RConstEval(PTreeNode&);
	void RToImp(PTreeNode&);
	void RToDis(PTreeNode&);
	void RToCon(PTreeNode&);
	void RToConDis(PTreeNode&);
	void RToCNF(PTreeNode&);
	void RToDNF(PTreeNode&);
	void FindOper(PTreeNode&,char&);
	void ChangeOper(PTreeNode&,char&);
	void EvlConst1(PTreeNode&);
	void Implication(PTreeNode&);
	void Disjunction(PTreeNode&);
	void Conjunction(PTreeNode&);
	void Distribution(PTreeNode&,PTreeNode&);
	void CopyNode(PTreeNode&,PTreeNode&);
	void ShCopyNode(PTreeNode&,PTreeNode&);
	void Exchange(PTreeNode&,PTreeNode&);
	void SortElm(PTreeNode&);
	void ReduceElm(PTreeNode&);
	void Bubble(PTreeNode&);
	void RRunner(PTreeNode&);
	void RMinimize(PTreeNode&);
	void RReduceElm(PTreeNode&,PTreeNode&);
	void IdCom(PTreeNode&,PTreeNode&,PTreeNode&);
	void Thread();
	void UnThread();
	void Minimize();
	void AbsExt(PTreeNode&,PTreeNode&,int&,char);
};



class TEditorApp : public TApplication
{

public:

		TEditorApp();

		virtual void handleEvent( TEvent& event );
		static TMenuBar *initMenuBar( TRect );
		static TStatusLine *initStatusLine( TRect );
		virtual void outOfMemory();

private:

		EditWindow1 *openEditor( const char *fileName, Boolean visible );
		void fileOpen();
		void fileNew();
    void changeDir();
    void dosShell();
    void showClip();
    void tile();
    void cascade();
};

extern TEditWindow *clipWindow;

ushort execDialog( TDialog *d, void *data );
ushort doEditDialog( int dialog, ... );

