/*----------------------------------------------------------*/
/*                                                          */
/*   Turbo Vision 1.0                                       */
/*   Copyright (c) 1991 by Borland International            */
/*                                                          */
/*   Turbo Vision TVEDIT source file                        */
/*----------------------------------------------------------*/

#define Uses_TApplication
#define Uses_TEditWindow
#define Uses_TDeskTop
#define Uses_TRect
#define Uses_TEditor
#define Uses_TFileEditor
#define Uses_TFileDialog
#define Uses_TChDirDialog
#define Uses_MsgBox
#define Uses_TRadioButtons
#define Uses_TSItem
#define Uses_TCheckBoxes
#define Uses_TLabel
#define Uses_TInputLine
#define Uses_TButton
#define Uses_TWindow
#define Uses_TMenuBar
#define Uses_TSubMenu
#define Uses_TKeys
#define Uses_TMenuItem
#define Uses_TStatusLine
#define Uses_TStatusItem
#define Uses_TStatusDef
#define Uses_TPoint
#define Uses_Desktop
#include <tv.h>

#include "tvedit.h"

#include <stdlib.h>
#include <stdarg.h>
#include <strstrea.h>
#include <iomanip.h>
typedef char *_charPtr;
typedef TPoint *PPoint;

TEditWindow *clipWindow;

EditWindow1::EditWindow1(const TRect &Bounds,const char *FileName,int ANumber)
: TEditWindow(Bounds,FileName,ANumber),TWindowInit(&TEditWindow::initFrame)
{
		F=new Formula();
		F->Protocol=this;
		Ft.checkBoxData=1;
		Ft.radioButtonData=3;
}

EditWindow1::~EditWindow1()
{
	delete F;
	TEditWindow::~TEditWindow();
}

EditWindow1 *TEditorApp::openEditor( const char *fileName, Boolean visible )
{
		TRect r = deskTop->getExtent();
		TView *p = validView( new EditWindow1( r, fileName, wnNoNumber ) );
		if( !visible )
				p->hide();
		deskTop->insert( p );
		return (EditWindow1 *)p;
}

TEditorApp::TEditorApp() :
		TProgInit( TEditorApp::initStatusLine,
							 TEditorApp::initMenuBar,
							 TEditorApp::initDeskTop
						 ),
		TApplication()
{

		TCommandSet ts;
		ts.enableCmd( cmSave );
		ts.enableCmd( cmSaveAs );
		ts.enableCmd( cmCut );
		ts.enableCmd( cmCopy );
    ts.enableCmd( cmPaste );
		ts.enableCmd( cmClear );
		ts.enableCmd( cmUndo );
		disableCommands( ts );


		TEditor::editorDialog = doEditDialog;
		clipWindow = openEditor( 0, False );
		if( clipWindow != 0 )
				{
				TEditor::clipboard = clipWindow->editor;
				TEditor::clipboard->canUndo = False;
				}
		messageBox("(c) Hashim Habiballa, 1996.",mfInformation|mfOKButton);
}

ushort execDialog( TDialog *d, void *data )
{
		TView *p = TProgram::application->validView( d );
    if( p == 0 )
				return cmCancel;
		else
				{
				if( data != 0 )
						p->setData( data );
				ushort result = TProgram::deskTop->execView( p );
				if( result != cmCancel && data != 0 )
						p->getData( data );
        TObject::destroy( p );
				return result;
        }
}
ushort doEditDialog( int dialog, ... )
{
		va_list arg;

		char buf[80];
		ostrstream os( buf, sizeof( buf ) );
		switch( dialog )
				{
				case edOutOfMemory:
						return messageBox( "Not enough memory for this operation",
															 mfError | mfOKButton );
				case edNothing:
						return messageBox( "No selected text.",
															 mfError | mfOKButton );
				case edOK:
						return messageBox( "Compilation successful.",
															 mfError | mfOKButton );
				case edillchar:
						return messageBox( "Illegal character.",
															 mfError | mfOKButton );
				case edmissoper:
						return messageBox( "Missing operator.",
															 mfError | mfOKButton );
				case edmissexp:
						return messageBox( "Missing expression.",
															 mfError | mfOKButton );
				case edmissbra:
						return messageBox( "Missing right bracket.",
															 mfError | mfOKButton );
				case edunexpbra:
						return messageBox( "Unexpected right bracket.",
															 mfError | mfOKButton );
				case edinsertfail:
						return messageBox( "Breaking down during inserting a text.",
															 mfError | mfOKButton );

				case edReadError:
						{
						va_start( arg, dialog );
						os << "Error reading file " << va_arg( arg, _charPtr )
							 << "." << ends;
						va_end( arg );
						return messageBox( buf, mfError | mfOKButton );
						}
				case edWriteError:
						{
						va_start( arg, dialog );
						os << "Error writing file " << va_arg( arg,_charPtr )
							 << "." << ends;
						va_end( arg );
						return messageBox( buf, mfError | mfOKButton );
						}
				case edCreateError:
						{
						va_start( arg, dialog );
						os << "Error creating file " << va_arg( arg, _charPtr )
							 << "." << ends;
						va_end( arg );
						return messageBox( buf, mfError | mfOKButton );
						}
        case edSaveModify:
						{
						va_start( arg, dialog );
						os << va_arg( arg, _charPtr )
							 << " has been modified. Save?" << ends;
						va_end( arg );
						return messageBox( buf, mfInformation | mfYesNoCancel );
						}
        case edSaveUntitled:
						return messageBox( "Save untitled file?",
															 mfInformation | mfYesNoCancel );
				case edSaveAs:
						{
						va_start( arg, dialog );
						return execDialog( new TFileDialog( "*.*",
																								"Save file as",
																								"~N~ame",
																								fdOKButton,
																								101 ), va_arg( arg, _charPtr ) );
						}


				}
}

#pragma warn .rvl


void EditWindow1::DoDialog()
{ 		TDialog *pd = new TDialog( TRect( 20, 6, 70, 18), "Format" );
		if( pd )
				{
				TView *b = new TCheckBoxes( TRect( 3, 3, 18, 4),
						new TSItem( "~R~esults", 0 )
						);
				pd->insert( b );

				pd->insert( new TLabel( TRect( 2, 2, 10, 3), "Output", b ));

				b = new TRadioButtons( TRect( 20, 3, 48, 7),
						new TSItem( "~C~omments + Evaluations",
						new TSItem( "~S~tep by step + Comment",
						new TSItem( "~O~nly step by step",
						new TSItem( "~N~othing", 0 )
						))));
				pd->insert( b );

				pd->insert( new TLabel( TRect( 21, 2, 33, 3), "Details", b ));

				pd->insert( new TButton( TRect( 15, 9, 25, 11 ), "~O~K", cmOK,
										bfDefault ));
				pd->insert( new TButton( TRect( 28, 9, 38, 11 ), "~C~ancel", cmCancel,
										bfNormal ));

				// we save the dialog data:
				pd->setData( &Ft );

				ushort control = TApplication::deskTop->execView( pd );

				// and read it back when the dialog box is successfully closed
				if( control != cmCancel )
						pd->getData( &Ft );
				}
		destroy( pd );
}



void StackInit()
{
		Stack=NULL;
}
void Put(char& chp,short pr)
{
		if (!lowMemory())
		 {
			StackNode *pom=new StackNode;
			pom->next=Stack;
			Stack=pom;
			pom->node=new TreeNode;
			Stack->node->character=chp;
			pom->node->left=NULL;
			pom->node->right=NULL;
			pom->node->prior=pr;
			pom->node->neg=0;
		 }
		 else error=mem;
}

StackNode* Cut()
{
		 if (Stack!=NULL)
			{
			 StackNode* pom=Stack;
			 Stack=Stack->next;
			 return pom;
			}
}

void DisposeStack()
{ StackNode *pte;
	/*	if (Stack!=NULL)
		 {	pte=Cut();
			delete pte;
		 } */
	 while (Stack!=NULL)
	 { pte=Cut();
		 delete(pte->node);
		 delete(pte);
	 }
}


void SInsert(StackNode* &p)
{
		 p->next=Stack;
		 Stack=p;
}

void Action(char chr,short pr)
{
	 Put(chr,pr);
	 StackNode* pom=Cut();
	 pom->node->right=Stack->node;
	 delete Cut();
	 pom->node->left=Stack->node;
	 delete Cut();
	 SInsert(pom);
}
char ch;
long pos;

void EditWindow1::GetChar()
{
		if (error==OK)
			{
				do
					if (pos>=editor->selEnd)
						ch='\x0';
					else
							ch=editor->bufChar(pos++);
				while ((ch>='\x01')&&(ch<='\x20'));
				if (!((ch>='a')&&(ch<='z')||(ch>='A')&&(ch<='Z')
						||(ch=='0')||(ch=='1')||(ch=='\0')
						||(ch=='&')||(ch=='|')||(ch=='~')
						||(ch=='>')||(ch=='=')||(ch=='(')
						||(ch==')')&&(error==OK))) error=illchar;
			}
}

void EditWindow1::ICE()
{
 if (error==OK)
	{if  (ch=='~')
				{	GetChar();
					ICE();
					Stack->node->neg=!(Stack->node->neg);}
	 else
	 if	((ch>='a')&&(ch<='z')||(ch>='A')&&(ch<='Z')||(ch=='0')||(ch=='1'))
		 {			Put(ch,6);
					GetChar();}
	 else
	 if	(ch=='(')
		 {		GetChar();
					Exp1();
					if ((ch!=')')&&(error==OK)) error=missbra;
					GetChar();
		 }
		else error=missexp;

	}
}

void EditWindow1::Exp4()
{
	if (error==OK)
		{
			ICE();
			while ((ch=='&')&&(error==OK))
				{
				 GetChar();
				 ICE();
				 if (error==OK) Action('&',4);
				}
		}
}

void EditWindow1::Exp3()
 {
	if (error==OK)
		{
			Exp4();
			while ((ch=='|')&&(error==OK))
				{
				 GetChar();
				 Exp4();

				 if (error==OK) Action('|',3);

				}
		}
 }

void EditWindow1::Exp2()
 {
	if (error==OK)
		{
			Exp3();
			while ((ch=='>')&&(error==OK))
				{
				 GetChar();
				 Exp3();
				 if (error==OK) Action('>',2);
				}
		}
 }

 void EditWindow1::Exp1()
 {
	if (error==OK)
		{
			Exp2();
			while ((ch=='=')&&(error==OK))
				{
				 GetChar();
				 Exp2();
				 if (error==OK) Action('=',1);
				}
		}
 }




void EditWindow1::XComp()
 {
	StackInit();
	pos=editor->selStart;
	error=OK;
	GetChar();
	if (error==OK) Exp1();
	if ((ch==')')&&(error==OK)) error=unexpbra;
	if ((ch=='\x0')&&(error==OK)) error=endcomp;
	if ((ch!='\x0')&&(error==OK)) error=missoper;
	if (error==endcomp)
	 {
			error=OK;
			F->Stree=Stack->node;
			delete Stack;
			editor->setSelect(pos,pos,True);
			InsertLine();
	 }
	else
		 {
			if (Stack!=NULL)
				 {
					 F->RDisposeTree(Stack->node);
				 }
			DisposeStack();

			editor->setSelect(pos - 1,pos - 1,True);
			InsertString(" ");
			editor->setSelect(pos - 1,pos - 1,True);
		 }
 switch (error)
 {
 case	illchar: doEditDialog(edillchar);break;
 case	missoper: doEditDialog(edmissoper);break;
 case	missbra: doEditDialog(edmissbra);break;
 case	missexp: doEditDialog(edmissexp);break;
 case	unexpbra: doEditDialog(edunexpbra);break;
 case	mem : doEditDialog(edOutOfMemory);
 }

 }

void EditWindow1::Decision()
 {
	 if (F!=NULL)
		 {
			 F->ToDNF();
			 F->Minimize();
			 switch (F->Stree->character)
			 {
			 case '0':
							InsertString("This formula is not consistent.");
							InsertLine();break;

			 case '1':
							InsertString("This formula is valid.");
							InsertLine();break;

			 default:

					 InsertString("This formula is consistent.Its models "
						"can be expressed as DNF:");
					 InsertLine();
					 XDecomp();

			 }
		 }
 }

void Formula::RDisposeTree(PTreeNode &tr)
 {

			 if (tr->prior!=6)
				 {
					 if (tr->left!=NULL) RDisposeTree(tr->left);
					 if (tr->right!=NULL) RDisposeTree(tr->right);
				 }
			 delete tr;
 }

void Formula::DisposeTree()
 {
	 if (Stree!=NULL) RDisposeTree(Stree);
 }

void Formula::CopyNode(PTreeNode &p1,PTreeNode &p2)
{
	 if (p1!= NULL)
	 {
		 p2=new TreeNode;
		 p2->character=p1->character;
		 p2->left=p1->left;
		 p2->right=p1->right;
		 p2->neg=p1->neg;
		 p2->prior=p1->prior;
	 }
 }

void Formula::ShCopyNode(PTreeNode &p1,PTreeNode &p2)
{
	 if ((p1!= NULL)&&(p2!=NULL))
	 {
		 p2->character=p1->character;
		 p2->left=p1->left;
		 p2->right=p1->right;
		 p2->neg=p1->neg;
		 p2->prior=p1->prior;
	 }
 }



void Formula::RCopyTree(PTreeNode &p1,PTreeNode &p2)
{
			 CopyNode(p1,p2);
			 if (p1->prior!=6)
				 {
					 if (p1->left!=NULL)  RCopyTree(p1->left,p2->left);
					 if (p1->right!=NULL)  RCopyTree(p1->right,p2->right);
				 }
 }

void Formula::CopyTree(PTreeNode &p2)
{
	 if (Stree!=NULL)  RCopyTree(Stree,p2);
}


PTreeNode pompt1,pompt2,pompt3,pompt4;
void Find1(PTreeNode &p,char& pch)
{
		 if (pompt2==NULL)
		 {
			 if (p->character==pch)
				 {
					 pompt2=p;p=pompt3;
				 }
			 if (p->prior!=6)
				 {
					 if (p->left!=NULL)  Find1(p->left,pch);
					 if (p->right!=NULL)  Find1(p->right,pch);
				 }
		 }
	 }

void Formula::FindOper(PTreeNode &p1,char &pch)
{
			pompt2=NULL;pompt3=p1->right;
			if (p1->left!=NULL)  Find1(p1->left,pch);
			if (pompt2!=NULL)
				{
					p1->right=p1->left;p1->left=pompt2;
				}
			else
				{
					pompt3=p1->left;
					if (p1->right!=NULL)  Find1(p1->right,pch);
					if (pompt2!=NULL)  p1->left=pompt2;
				}
}


void Formula::ChangeOper(PTreeNode &p,char &ch)
{
	 if (p!=NULL)
		 {
			 p->character=ch;
			 switch (ch)
			 {
				case '=': p->prior=1;break;
				case '>': p->prior=2;break;
				case '|': p->prior=3;break;
				case '&': p->prior=4;break;
			 }
		 }
	}

void EditWindow1::InsertFail()
{
		doEditDialog(edinsertfail);
		error=insfail;
}
char chpoint;
void EditWindow1::InsertLine()
{
	if (error!=insfail)
		{
			chpoint='\x0d';
			if (!(editor->insertText(&chpoint,1,False)))  InsertFail();
			chpoint='\x0a';
			if (!(editor->insertText(&chpoint,1,False)))  InsertFail();
		 }
	}

void EditWindow1::InsertString(char* s)
{
unsigned i=0;
		while (s[i]!='\x0')
			{
			 InsertCharacter(s[i++]);
			}
	}

void EditWindow1::InsertCharacter(char x)
{

		if (error!=insfail)
			{
				if (editor->curPos.x >= 78)   InsertLine();
				chpoint=x;
				if (!(editor->insertText(&chpoint,1,False)))  InsertFail();
			}
}
void EditWindow1::Dive(PTreeNode &node)
{
				 if (node->neg==!0)
					 {
						 InsertString("~");
						 if (node->prior!=6)
							 {
								 InsertString("(");
							 }
					 }
				 if (node->prior != 6)
					 if ((node->prior>node->left->prior)
							 &&(!(node->left->neg)))
							{
								InsertString("(");
								Dive(node->left);
								InsertString(")");
							}
					 else Dive(node->left);
				 InsertCharacter(node->character);
				 if (node->prior != 6)
					 if (((node->prior>node->right->prior)||
							((node->prior==2)&&(node->right->prior==2)))
							 &&(!(node->right->neg)))
							{
								InsertString("(");
								Dive(node->right);
								InsertString(")");
							}
					 else Dive(node->right);
				 if ((node->prior!=6)&&(node->neg==!0))
					 {
						 InsertString(")");
					 }


}

void EditWindow1::XDecomp()
	 {
		 if (F->Stree!=NULL)
			{
			 Dive(F->Stree);
			 InsertLine();
			}
	 }



// Propositional logic laws



void Formula::EvlConst1(PTreeNode &p)
{
short left;char pchar;
 if ((p!=NULL)&&(p->prior!=6))
 {
	 pompt1=NULL;pompt2=NULL;
	 if ((p->left->character=='0'||p->left->character=='1')&&(p->left!=NULL))
		 {
			 pompt1=p->right;
			 pompt2=p->left;
			 left=!0;
		 }
	 else if ((p->right->character=='0'||p->right->character=='1')&&(p->right!=NULL))
					{
						pompt1=p->left;
						pompt2=p->right;
						left=0;
					}
	 if (pompt1!=NULL)
		 {
			 if (pompt2->neg)
				 {
					 pompt2->neg=0;
					 if (pompt2->character=='0')  pompt2->character='1';
					 else pompt2->character='0';
				 }
		 pchar=p->character;
		 delete p;
		 switch (pchar)
		 {
		 case	'=':
						if (pompt2->character=='0')  pompt1->neg=!(pompt1->neg);
						p=pompt1;RDisposeTree(pompt2);break;

		 case	'>':
						if (pompt2->character=='0')
							if (left)
								 {
									 p=pompt2;p->character='1';RDisposeTree(pompt1);
								 }
							else {
										 p=pompt1;p->neg=!(p->neg);RDisposeTree(pompt2);
									 }
						else
						if (pompt2->character=='1')
							if (left)
								{
									p=pompt1;RDisposeTree(pompt2);
								}
							else {
										 p=pompt2;RDisposeTree(pompt1);
									 }
					 break;

			case '|':if (pompt2->character=='0')
								{
									p=pompt1;RDisposeTree(pompt2);
								}
					 else {
									p=pompt2;RDisposeTree(pompt1);
								};
					 break;
			case '&':if (pompt2->character=='0')
								{
									p=pompt2;RDisposeTree(pompt1);
								}
					 else {
									p=pompt1;RDisposeTree(pompt2);
								};

			}

			 if ((p->character=='0')&&(p->neg))
				{
					p->character='1';p->neg=0;
				}
		 else if ((p->character=='1')&&(p->neg))
				{
					p->character='0';p->neg=0;
				}
		 if (Protocol!=NULL)
				if (Protocol->Ft.radioButtonData == 0)
						 {
							 Protocol->InsertString("Constant evaluation:");
							 Protocol->XDecomp();
						 }
		}
	}
	}


void Formula::Implication(PTreeNode& p)
{
 char pchar;
	 if (p!=NULL)
		 {
			 pchar='>';
			 if (p->character == '=')
				 {
					 RCopyTree(p->left,pompt2);RCopyTree(p->right,pompt1);
					 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=0;
					 pompt3->right=p->right;pompt3->left=p->left;p->left=pompt3;
					 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
					 pompt3->left=pompt1;pompt3->right=pompt2;p->right=pompt3;
					 ChangeOper(p,pchar);p->neg=!(p->neg);
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Equivalence to implication:");
							 Protocol->XDecomp();
						 }
				 }
			 else if (p->character == '&')
				 {
					 ChangeOper(p,pchar);p->neg=!(p->neg);
					 p->right->neg=!(p->right->neg);
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Conjunction to implication:");
							 Protocol->XDecomp();
						 }
				 }
			 else if (p->character == '|')
				 {
					 ChangeOper(p,pchar);p->left->neg=!(p->left->neg);
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Disjunction to implication:");
							 Protocol->XDecomp();
						 }
				 }
		 }
	}


void Formula::Disjunction(PTreeNode& p)
{
char pchar;
			if (p!=NULL)
		 {
			 pchar='|';
			 if (p->character == '=')
				 {
					 if (p->neg == !0)
					 {
						 RCopyTree(p->left,pompt2);RCopyTree(p->right,pompt1);
						 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->right=p->right;pompt3->left=p->left;
						 pompt3->left->neg=!(pompt3->left->neg);p->left=pompt3;
						 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->left=pompt1;pompt3->right=pompt2;
						 pompt3->left->neg=!(pompt3->left->neg);p->right=pompt3;
						 ChangeOper(p,pchar);p->neg=!(p->neg);

					 }
					 else
					 {
						 RCopyTree(p->left,pompt2);RCopyTree(p->right,pompt1);
						 pompt3=new TreeNode;;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->right=p->right;pompt3->left=p->left;p->left=pompt3;
						 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->left=pompt1;pompt3->right=pompt2;
						 pompt3->left->neg=!(pompt3->left->neg);
						 pompt3->right->neg=!(pompt3->right->neg);p->right=pompt3;
						 ChangeOper(p,pchar);
					 }
					if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Equivalence to disjunction:");
							 Protocol->XDecomp();
						 }

				 }
				 else if (p->character == '&')
				 {
					 ChangeOper(p,pchar);p->neg=!(p->neg);
					 p->right->neg=!(p->right->neg);
					 p->left->neg=!(p->left->neg);
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Conjuction to disjunction:");
							 Protocol->XDecomp();
						 }
				 }

			 else if (p->character == '>')
				 {
					 ChangeOper(p,pchar);p->left->neg=!(p->left->neg);
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Implication to disjunction:");
							 Protocol->XDecomp();
						 }
				 }
	 }
}


void Formula::Conjunction(PTreeNode& p)
{ char pchar;
		 if (p!=NULL)
		 {
			 pchar='&';
			 if (p->character == '=')
				 {
					 if (p->neg == !0)
					 {
						 RCopyTree(p->left,pompt2);RCopyTree(p->right,pompt1);
						 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->right=p->right;pompt3->left=p->left;
						 pompt3->left->neg=!(pompt3->left->neg);
						 pompt3->right->neg=!(pompt3->right->neg);p->left=pompt3;
						 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->left=pompt1;pompt3->right=pompt2;p->right=pompt3;
						 ChangeOper(p,pchar);p->neg=!(p->neg);
					 }
					 else
					 {
						 RCopyTree(p->left,pompt2);RCopyTree(p->right,pompt1);
						 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->right=p->right;pompt3->left=p->left;
						 pompt3->right->neg=!(pompt3->right->neg);p->left=pompt3;
						 pompt3=new TreeNode;ChangeOper(pompt3,pchar);pompt3->neg=!0;
						 pompt3->left=pompt1;pompt3->right=pompt2;
						 pompt3->right->neg=!(pompt3->right->neg);
						 p->right=pompt3;
						 ChangeOper(p,pchar);
					 }
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Equivalence to conjunction:");
							 Protocol->XDecomp();
						 }
				 }

			 else if (p->character == '|')
				 {
					 ChangeOper(p,pchar);p->neg=!(p->neg);
					 p->right->neg=!(p->right->neg);
					 p->left->neg=!(p->left->neg);
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Disjunction to conjunction:");
							 Protocol->XDecomp();
						 }
				 }
			 else if (p->character == '>')
				 {
					 ChangeOper(p,pchar);p->neg=!(p->neg);
					 p->right->neg=!(p->right->neg);
					 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Implication to conjunction:");
							 Protocol->XDecomp();
						 }
				 }
		 }
	}

void Formula::Distribution(PTreeNode& p1,PTreeNode& p2)
{
char pchar,pchar2;

		if ((p1!=NULL)&&(p2!=NULL)&&(p1->character=='&'||p1->character=='|')
			&&(p2->character=='&'||p2->character=='|'))
			{
				RCopyTree(p2->right,pompt1);
				pchar=p1->character;
				pchar2=p2->character;
				ChangeOper(p2,pchar);ChangeOper(p1,pchar2);pompt2=p1->right;
				p1->right=pompt1;pompt3=new TreeNode;ChangeOper(pompt3,pchar2);
				pompt3->neg=0;pompt3->left=pompt2;
				pompt3->right=p2->right;p2->right=pompt3;
				if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Distribution:");
							 Protocol->XDecomp();
						 }
			}
	 }

void Formula::IdCom(PTreeNode& p1,PTreeNode& p2,PTreeNode& master)
{
		 if ((p1!=NULL)&&(p2!=NULL)&&(p1->prior==6)&&(p2->prior==6)&&
				(!(p1->character=='0'||p1->character=='1'))&&
				(!(p2->character=='0'||p2->character=='1')))
			 {
				 if (p1->character==p2->character)
					 {
						 if (p1->neg==p2->neg)
							 {
								 switch (master->character)
								 {
								 case '&':p1->character='1';break;
								 case '|':p1->character='0';break;
									}
								 p1->neg=0;
								 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Idempotention:");
							 Protocol->XDecomp();
							 }
						 }
						 else
						 {
								 switch (master->character)
								 {
									case '&':p1->character='0';break;
									case '|':p1->character='1';break;
									}
								 p1->neg=0;
								 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Complementarity:");
							 Protocol->XDecomp();
						 }
					 }
					 }
			 }
	 }

int o,Ok,left,right,cst;
PTreeNode pom1,pom2,pom3,pom4,pt;

void Find(PTreeNode& tr)
{
		 if (tr->prior!=6)
				 {
					 Find(tr->left);
					 Find(tr->right);
				 }
			 else {
							if (!(tr->character=='0'||tr->character=='1'))
							if (pt==NULL)  pt=tr;
							if (tr->character=='0'||tr->character=='1')  cst=!0;
						}
}

void Formula::AbsExt(PTreeNode& p1,PTreeNode& p2,int& o,char par)
{
		 pom1=p1;pom2=p2;pom3=NULL;pom4=NULL;Ok=!0;left=0;
		 right=0;cst=0;
		 pt=NULL;Find(p1);pom1=pt;
		 if (cst==0)
			 {
				 pt=NULL;Find(p2);pom2=pt;
			 }
		 if ((pom1!=NULL)&&(pom2!=NULL)&&(cst==0))
		 {
		 do
		 {
			 if (((pom1!=NULL)&&(pom2!=NULL)&&(pom1->character>pom2->character))||
					((pom1==NULL)&&(pom2!=NULL)))
				 {
					 right=!0;
					 if (pom2!=NULL)  pom2=pom2->right;
				 }
			 if (((pom1!=NULL)&&(pom2!=NULL)&&(pom1->character<pom2->character))||
					((pom1!=NULL)&&(pom2==NULL)))
				 {
					 left=!0;
					 if (pom1!=NULL)  pom1=pom1->right;
				 }
			 if ((pom1->character==pom2->character)&&(pom1->neg!=pom2->neg))
				 if ((pom3!=NULL)&&(pom4!=NULL))  Ok=0;
				 else
					 {
						 pom3=pom1;
						 pom4=pom2;
					 }
			 if ((pom1!=NULL)&&(pom2!=NULL)&&(pom1->character==pom2->character))
					 {
						 if (pom1!=NULL)  pom1=pom1->right;
						 if (pom2!=NULL)  pom2=pom2->right;
					 }
			 }
			 while (!((Ok==0)||((pom1==NULL)&&(pom2==NULL))));
			 pt=NULL;Find(p1);pom1=pt;
			 pt=NULL;Find(p2);pom2=pt;
			 if ((!((left==!0)&&(right==!0)))&&(Ok==!0))
				 {
					 if ((left==0)&&(right==0))
						 if (pom3==NULL)
						 {  switch (par)
								{

								case '&':pom1->character='1';break;
								case '|':pom1->character='0';
								}
								pom1->neg=0;
								if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Total absorption:");
							 Protocol->XDecomp();
						 }
							}
					 else
					 {
							 switch (par)
               {
							 case '&':
											pom1->character='1';
											pom4->character='0';
											break;
							 case '|':
											pom1->character='0';
											pom4->character='1';

							 }
							 pom1->neg=0;pom4->neg=0;
							 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Extension:");
							 Protocol->XDecomp();
						 }
						 }
				 if (left==!0)
					 if (pom3==NULL)
						 {
							 switch (par)
							 {
							 case '&': pom1->character='1';break;
							 case '|': pom1->character='0';
							 }
							 pom1->neg=0;
							 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Absorption:");
							 Protocol->XDecomp();
						 }
						 }
					 else
						 {
							 switch	(par)
							 {
							 case '&': pom3->character='0';break;
							 case '|': pom3->character='1';
							 }
							 pom3->neg=0;
							 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Absorption of negation:");
							 Protocol->XDecomp();
						 }
						 }
				 if (right==!0)
					 if (pom4==NULL)
						 {
							 switch (par)
							 {
							 case '&': pom2->character='1';break;
							 case '|': pom2->character='0';
							 }
							 pom2->neg=0;
							 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Absorption:");
							 Protocol->XDecomp();
						 }
						 }
           else
						 {
							 switch (par)
							 {
							 case '&': pom4->character='0';break;
							 case '|': pom4->character='1';
							 }
							 pom4->neg=0;
							 if (Protocol!=NULL)
					 if (Protocol->Ft.radioButtonData <= 2)
						 {
							 if (Protocol->Ft.radioButtonData <= 1)
									 Protocol->InsertString("Absorption of negation:");
							 Protocol->XDecomp();
						 }
						 }
				 Thread();
				 o=!0;
		 }
	 }
	 }



void Formula::RConstEval(PTreeNode& tr)
{
			if  (tr->prior != 6)
				{
					RConstEval(tr->left);
					RConstEval(tr->right);
					EvlConst1(tr);
				}
		}

void Formula::ConstEval()
 {		if (Stree!=NULL)
			{
				RConstEval(Stree);

			}
	}


void Formula::RToImp(PTreeNode& tr)
	{
		if  (tr->prior != 6)
			{
				Implication(tr);
				RToImp(tr->left);
				RToImp(tr->right);
			}
	}

void Formula::ToImp()
	{
		if (Stree!=NULL)
			{
				RToImp(Stree);
			}
	}

void Formula::RToDis(PTreeNode& tr)
	{
		if (tr->prior != 6)
			{
				Disjunction(tr);
				RToDis(tr->left);
				RToDis(tr->right);
			}
	}

void Formula::ToDis()
	{
		if (Stree!=NULL)
			{
				RToDis(Stree);

			}
	}

void Formula::RToCon(PTreeNode& tr)
	{
		if (tr->prior!=6)
			{
				Conjunction(tr);
				RToCon(tr->left);
				RToCon(tr->right);
			}
	}

void Formula::ToCon()
	{
		if (Stree!=NULL)
			{
				RToCon(Stree);

			}
	}

void Formula::RToConDis(PTreeNode& tr)
	{
		if (tr->prior!=6)
			{
				if ((tr->neg)||(!(tr->character=='&'||tr->character=='|')))
				 Conjunction(tr);
				if (tr->neg)  Disjunction(tr);
				RToConDis(tr->left);
				RToConDis(tr->right);
			}
	}

void Formula::ToConDis()
	{
		if (Stree!=NULL)
		 {
			 RToConDis(Stree);

		 }
	}

void Formula::RReduceElm(PTreeNode& tr,PTreeNode& tm)
	{
	if ((tr->character==tm->character)||(tr->prior==6))
	{
		if (tr->prior!=6)
			{
				RReduceElm(tr->left,tm);
				RReduceElm(tr->right,tm);
			}
		else
			{
				if (pompt1!=NULL)  IdCom(pompt1,tr,tm);
				pompt1=tr;
			}
	}
}

void Formula::ReduceElm(PTreeNode &t)
{
		pompt1=NULL;
		RReduceElm(t,t);
}

void Formula::Exchange(PTreeNode &p1,PTreeNode& p2)
{	PTreeNode pom;
		pom=new TreeNode;
		ShCopyNode(p1,pom);
		ShCopyNode(p2,p1);
		ShCopyNode(pom,p2);
		delete pom;
}

int op;
char pchar;
void Formula::Bubble(PTreeNode& t)
{
				if ((t->character==pchar)||(t->prior==6))
				{
					if (t->prior!=6)
						{
							Bubble(t->left);
							Bubble(t->right);
						}
					else
					{
						if ((pompt1!=NULL)&&(pompt1->character>t->character))
							{
								Exchange(pompt1,t);
								op=!0;
							}
						pompt1=t;
					}
				}
			}

void Formula::SortElm(PTreeNode& tr)
{
			op=!0;
			pchar=tr->character;
			while (op)
			 {
				op=0;
				pompt1=NULL;
				Bubble(tr);
			 }
		}

void Formula::RToCNF(PTreeNode& tr)
	{
		if  ((tr->prior!=6)&&(!(lowMemory())))
			{
				if (tr->character!=andchar)
					{
						FindOper(tr,andchar);
						if (tr->left->character!=andchar)
							 {
								 SortElm(tr);
								 ReduceElm(tr);
							 }
						if (tr->left->character==andchar)  Distribution(tr->left,tr);
					}
				RToCNF(tr->left);
				RToCNF(tr->right);
				if (tr->character==andchar)
				 {
					 RConstEval(tr->left);
					 RConstEval(tr->right);
				 }
			}

	}


void Formula::ToCNF()
	{
		if (Stree!=NULL)
		{
			ToConDis();
			ConstEval();
			RToCNF(Stree);
			if (lowMemory())
				{
					doEditDialog(edOutOfMemory);
					DisposeTree();
					Stree=NULL;
				}
			else
			{
				SortElm(Stree);
				ReduceElm(Stree);
				ConstEval();
			 }
		}
	}

void Formula::RToDNF(PTreeNode& tr)
	{
		if ((tr->prior!=6)&&(!(lowMemory())))
			{
				if (tr->character!=orchar)
					{
						FindOper(tr,orchar);
						if (tr->left->character!=orchar)
							 {
								 SortElm(tr);
								 ReduceElm(tr);
							 }
						if (tr->left->character==orchar)  Distribution(tr->left,tr);

					}
				RToDNF(tr->left);
				RToDNF(tr->right);
				if (tr->character==orchar)
				 {
					 RConstEval(tr->left);
					 RConstEval(tr->right);
				 }
			}
	}

void Formula::ToDNF()
	{
		if (Stree!=NULL)
		 {
			ToConDis();
			ConstEval();
			RToDNF(Stree);
			if (lowMemory())
				{
					doEditDialog(edOutOfMemory);
					DisposeTree();
					Stree=NULL;
				}
			else
			{
				SortElm(Stree);
				ReduceElm(Stree);
				ConstEval();

			 }
		 }
	}

void RThread(PTreeNode& tr)
		{
			if (tr->prior!=6)
				{
					RThread(tr->left);
					RThread(tr->right);
				}
			else if (!(tr->character=='1'||tr->character=='0'))
				{
					if (pompt1!=NULL)
						{
							pompt1->right=tr;tr->left=pompt1;
						}
					pompt1=tr;
				}
		}

void RDive(PTreeNode& t)
		{
			if (t->prior!=6)
				if (t->character==pchar)
					{
						RDive(t->left);
						RDive(t->right);
					}
				else if (!(t->character=='0'||t->character=='1'))
				{
					pompt1=NULL;
					RThread(t);
				}
		}


void Formula::Thread()
	{
		pompt1=NULL;pchar=Stree->character;RDive(Stree);
	}

void RUnThread(PTreeNode& tr)
		{
			if (tr->prior!=6)
				{
					RUnThread(tr->left);
					RUnThread(tr->right);
				}
			else
				{
					tr->right=NULL;tr->left=NULL;
				}
		}


void Formula::UnThread()
{
		RUnThread(Stree);
}
PTreeNode pompt5;
void Formula::RRunner(PTreeNode& tm)
{
				if ((tm->prior!=6)&&(tm->character==pchar))
					{
						RRunner(tm->left);
						RRunner(tm->right);
					}
				if ((tm->character!=pchar)&&(!(tm->character=='0'||tm->character=='1')))
				{
				if (pompt5==tm)  pompt5=NULL;
				 if (pompt5!=NULL)
					{
						AbsExt(tm,pompt5,op,pchar);
					}
				}
}

void Formula::RMinimize(PTreeNode& trx)
{
				if ((trx->prior!=6)&&(trx->character==pchar))
					{
						RMinimize(trx->left);
						RMinimize(trx->right);
					}
				if ((trx->character!=pchar)&&(!(trx->character=='0'
						||trx->character=='1')))
					{
						pompt5=trx;RRunner(Stree);
					}
}

void Formula::Minimize()
{    pompt5=NULL;
		 if ((Stree!=NULL)&&(Stree->prior!=6))
			 {
				 op=!0;
				 Thread();
				 while (op)
					 {
						 pchar=Stree->character;
						 op=0;
						 pompt5=NULL;
						 RMinimize(Stree);
						 ConstEval();
						 UnThread();
						 Thread();
					 }
				 UnThread();
				 if (Stree->prior!=6)
							 {
								 SortElm(Stree);
								 ReduceElm(Stree);
								 ConstEval();
							 }
			 }
	}


Formula::Formula()
{
	Stree=NULL;
	Protocol=NULL;
}

Formula::~Formula()
{
 //	DisposeTree;
}

void EditWindow1::handleEvent(TEvent& Event)
{
	 TEditWindow::handleEvent(Event);
	 if (Event.what!=evCommand) return;
	 else
	 {unsigned com=Event.message.command;
		if ((editor->selStart != editor->selEnd)&&
			 ((com==cmDis)||(com==cmCon)||
				(com==cmConDis)||(com==cmImp)||
				(com==cmDNF)||(com==cmCNF)||
				(com==cmEval)||(com==cmMinimalCNF)||
				(com==cmMinimalDNF)||(com==cmDecision)))
				 {		XComp();
						if (Error != OK) clearEvent(Event);
				 }
			switch (com)
			{
			case	cmCompile:
										if (editor->selStart<editor->selEnd) XComp();
										 else doEditDialog(edNothing);
										break;
			case	cmDecompile:
											XDecomp();
											break;
			case	cmDis    :
											 F->ToDis();
											 if (Ft.checkBoxData&1)  XDecomp();
											 break;
			case	cmCon    :
											 F->ToCon();
											 if (Ft.checkBoxData&1)  XDecomp();
											 break;
			case	cmConDis  :
											 F->ToConDis();
											 if (Ft.checkBoxData&1)  XDecomp();
											 break;
			case	cmImp      :
											 F->ToImp();
											 if (Ft.checkBoxData&1)  XDecomp();
											 break;
			case	cmDNF     :
											 F->ToDNF();
											 if (Ft.checkBoxData&1)  XDecomp();
											 break;
			case	cmCNF      :
											 F->ToCNF();
											 if (Ft.checkBoxData&1)  XDecomp();
											 break;
			case	cmEval     :
											 F->ConstEval();
											 if (Ft.checkBoxData&1)  XDecomp();
											 break;
			case	cmMinimalDNF :
												 F->ToDNF();
												 F->Minimize();
												 if (Ft.checkBoxData&1)  XDecomp();
												 break;
			case	cmMinimalCNF :
												 F->ToCNF();
												 F->Minimize();
												 if (Ft.checkBoxData&1)  XDecomp();
												 break;
			case	cmDecision   :
												Decision();
												break;

			 case	cmFormat : DoDialog();break;

			 default : return;
			}
		}
		clearEvent(Event);
}


void TEditorApp::fileOpen()
{
		char fileName[MAXPATH];
		strcpy( fileName, "*.*" );

		if( execDialog( new TFileDialog( "*.*", "Open file",
						"~N~ame", fdOpenButton, 100 ), fileName) != cmCancel )
				openEditor( fileName, True );
}

void TEditorApp::fileNew()
{
		openEditor( 0, True );
}

void TEditorApp::changeDir()
{
		execDialog( new TChDirDialog( cdNormal, 0 ), 0 );
}

void TEditorApp::dosShell()
{
		suspend();
		system("cls");
		cout << "Type EXIT to return...";
		system( getenv( "COMSPEC"));
		resume();
		redraw();
}

void TEditorApp::showClip()
{
		clipWindow->select();
		clipWindow->show();
}

void TEditorApp::tile()
{
		deskTop->tile( deskTop->getExtent() );
}

void TEditorApp::cascade()
{
		deskTop->cascade( deskTop->getExtent() );
}

void TEditorApp::handleEvent( TEvent& event )
{
		TApplication::handleEvent( event );
		if( event.what != evCommand )
				return;
		else
				switch( event.message.command )
            {
						case cmOpen:
								fileOpen();
								break;

						case cmNew:
								fileNew();
								break;

						case cmChangeDrct:
								changeDir();
								break;

            case cmDosShell:
								dosShell();
								break;

						case cmShowClip:
                showClip();
								break;

						case cmTile:
                tile();
								break;

						case cmCascade:
								cascade();
								break;

						default:
								return ;
						}
		clearEvent( event );
}


int main()
{
		TEditorApp editorApp;
		editorApp.run();
		return 0;
}


TMenuBar *TEditorApp::initMenuBar( TRect r )
{

			TSubMenu& sub1 = *new TSubMenu( "~F~ile", kbAltF ) +
				*new TMenuItem( "~O~pen", cmOpen, kbF3 ) +
				*new TMenuItem( "~N~ew", cmNew, kbNoKey ) +
				*new TMenuItem( "~S~ave", cmSave, kbF2, hcNoContext, "F2" ) +
        *new TMenuItem( "S~a~ve as...", cmSaveAs, kbNoKey ) +
						 newLine() +
				*new TMenuItem( "~C~hange dir...", cmChangeDrct, kbNoKey ) +
				*new TMenuItem( "~D~OS shell", cmDosShell, kbNoKey ) +
				*new TMenuItem( "E~x~it", cmQuit, kbAltX, hcNoContext, "Alt-X" );

			TSubMenu& sub2 = *new TSubMenu( "~E~dit", kbAltE ) +
				*new TMenuItem( "~U~ndo", cmUndo, kbNoKey ) +
						 newLine() +
				*new TMenuItem( "Cu~t~", cmCut, kbShiftDel, hcNoContext, "Shift-Del" ) +
        *new TMenuItem( "~C~opy", cmCopy, kbCtrlIns, hcNoContext, "Ctrl-Ins" ) +
				*new TMenuItem( "~P~aste", cmPaste, kbShiftIns, hcNoContext, "Shift-Ins" ) +
				*new TMenuItem( "~S~how clipboard", cmShowClip, kbNoKey ) +
						 newLine() +
				*new TMenuItem( "~C~lear", cmClear, kbCtrlDel, hcNoContext, "Ctrl-Del" )+
				*new TMenuItem( "~F~ormat", cmFormat, kbAltT, hcNoContext, "Alt-T" );
			TSubMenu& sub3 = *new TSubMenu( "F~o~rmula", kbAltO ) +
				*new TMenuItem( "~C~onjunctions", cmCon, kbAltC,hcNoContext,"Alt-C" ) +
				*new TMenuItem( "~D~isjunctions", cmDis, kbAltD,hcNoContext,"Alt-D" ) +
				*new TMenuItem( "~I~mplications", cmImp, kbAltI,hcNoContext,"Alt-I" ) +
				*new TMenuItem( "~L~iterals", cmConDis, kbAltL,hcNoContext,"Alt-L" ) +
				*new TMenuItem( "Co~m~pile", cmCompile, kbCtrlF9,hcNoContext,"Ctrl-F9" ) +
				*new TMenuItem( "DNF", cmDNF, kbAltF7,hcNoContext,"Alt-F7" ) +
				*new TMenuItem( "CNF", cmCNF, kbCtrlF7,hcNoContext,"Ctrl-F7" ) +
				*new TMenuItem( "Minimal DNF", cmMinimalDNF, kbAltF8,hcNoContext,"Alt-F8" ) +
				*new TMenuItem( "Minimal CNF", cmMinimalCNF, kbCtrlF8,hcNoContext,"Ctrl-F8" ) +
				*new TMenuItem( "Dec~i~sion", cmDecision, kbF8,hcNoContext,"F8" ) +
				*new TMenuItem( "~E~valute", cmEval, kbAltV,hcNoContext,"Alt-V" ) ;

			TSubMenu& sub4 = *new TSubMenu( "~W~indows", kbAltW ) +
				*new TMenuItem( "~S~ize/move",cmResize, kbCtrlF5, hcNoContext, "Ctrl-F5" ) +
				*new TMenuItem( "~Z~oom", cmZoom, kbF5, hcNoContext, "F5" ) +
				*new TMenuItem( "~T~ile", cmTile, kbNoKey ) +
				*new TMenuItem( "C~a~scade", cmCascade, kbNoKey ) +
				*new TMenuItem( "~N~ext", cmNext, kbF6, hcNoContext, "F6" ) +
				*new TMenuItem( "~P~revious", cmPrev, kbShiftF6, hcNoContext, "Shift-F6" ) +
				*new TMenuItem( "~C~lose", cmClose, kbAltF3, hcNoContext, "Alt-F3" );

		r.b.y = r.a.y+1;
		return new TMenuBar( r, sub1 + sub2 + sub3 + sub4 );
}

TStatusLine *TEditorApp::initStatusLine( TRect r )
{
		r.a.y = r.b.y-1;
		return new TStatusLine( r,
        *new TStatusDef( 0, 0xFFFF ) +
						*new TStatusItem("~F2~ Save", kbF2, cmSave ) +
						*new TStatusItem( "~F3~ Open", kbF3, cmOpen ) +
            *new TStatusItem( "~Alt-F3~ Close", kbAltF3, cmClose ) +
						*new TStatusItem( "~F5~ Zoom", kbF5, cmZoom ) +
            *new TStatusItem( "~F6~ Next", kbF6, cmNext ) +
						*new TStatusItem( "~F10~ Menu", kbF10, cmMenu ) +
						*new TStatusItem( 0, kbCtrlF5, cmResize )
            );

}

void TEditorApp::outOfMemory()
{
		messageBox("Not enough memory for this operation.", mfError | mfOKButton );
}

#pragma warn -rvl

