unit MDIFrm95;

interface

uses WinTypes, WinProcs, Classes, Graphics, Controls, Printers,
  Menus, MDIEdt95, Dialogs, Forms, Unit1_95, ExtCtrls, ComCtrls;
type
  TFrameForm = class(TForm)
    OpenFileDialog: TOpenDialog;
    MainMenu1: TMainMenu;
    Open1: TMenuItem;
    Window1: TMenuItem;
    Tile1: TMenuItem;
    Cascade1: TMenuItem;
    ArrangeIcons1: TMenuItem;
    Separator3: TMenuItem;
    About1: TMenuItem;
    Help1: TMenuItem;
    About2: TMenuItem;
    Timer1: TTimer;
    StatusBar1: TStatusBar;
    procedure NewChild(Sender: TObject);
    procedure OpenChild(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Tile1Click(Sender: TObject);
    procedure Cascade1Click(Sender: TObject);
    procedure ArrangeIcons1Click(Sender: TObject);
    procedure About2Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  
end;

var
  FrameForm: TFrameForm;
  CurEdForm: TEditForm;

implementation

uses SysUtils;

{$R *.DFM}
function UsedMem:longint;
var x:THeapStatus;
begin
  x:=GetHeapStatus;
  UsedMem:=x.TotalAllocated;
end;


procedure TFrameForm.NewChild(Sender: TObject);
var
  EditForm: TEditForm;
begin
  CurEdForm:=EditForm;
  EditForm := TEditForm.Create(Application);
  EditForm.Show;
end;

procedure TFrameForm.OpenChild(Sender: TObject);
var
  EditForm: TEditForm;
begin
  if OpenFileDialog.Execute then
  begin
    CurEdForm:=EditForm;
    EditForm := TEditForm.Create(Self);
    EditForm.Open(OpenFileDialog.Filename);
    EditForm.Show;
  end;
end;

procedure TFrameForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFrameForm.Tile1Click(Sender: TObject);
begin
  Tile;
end;

procedure TFrameForm.Cascade1Click(Sender: TObject);
begin
  Cascade;
end;

procedure TFrameForm.ArrangeIcons1Click(Sender: TObject);
begin
  ArrangeIcons;
end;

procedure TFrameForm.About2Click(Sender: TObject);
begin
  AboutBox.Visible:=True;
  AboutBox.SetFocus;
end;

procedure TFrameForm.Help1Click(Sender: TObject);
begin
   Application.HelpFile:='windeal.hlp';
   Application.HelpCommand(HELP_CONTENTS,0);
end;






procedure TFrameForm.StatusBar1Click(Sender: TObject);
begin
   StatusBar1.Panels.Items[0].Text:=
   timetostr(time);
end;

function Memavail:longint;
  var x:THeapStatus;
  begin
    x:=GetHeapStatus;
    MemAvail:=x.TotalFree;
  end;

procedure TFrameForm.Timer1Timer(Sender: TObject);
begin
   StatusBar1.Panels.Items[0].Text:=
   timetostr(time);
   StatusBar1.Panels.Items[1].Text:=
   inttostr(UsedMem);
   StatusBar1.Panels.Items[2].Text:=
   inttostr(MemAvail);
   Application.ProcessMessages;
end;

end.



