unit MDIEdt95;
{$X+}
{$B-}
interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Printers,
  Dialogs, Menus, Clipbrd, StdCtrls, ExtCtrls, Buttons, ComCtrls;

type

     PSTreeNode=^TSTreeNode;   {tree node}
     TSTreeNode=record
      character:char;          {symbol : operator,proposition,constant}
      prior:byte;              {priority of symbol}
      neg:boolean;             {setting of negation}
      left:PSTreeNode;         {pointer to left subtree}
      right:PSTreeNode;                 {to right subtree}
     end;


     PSStackNode=^TSStackNode; { stack node containg tree node}
     TSStackNode=record        {during compilation}
      node:PSTreeNode;         {pointer to tree node}
      next:PSStackNode;        {pointer to next stack node}
     end;
     ErrorType=(OK,illchar,missoper,missexp,missbra,unexpbra,endcomp,
                insfail,mem);
       {error types = OK , illegal character , missing operator , expression,
                      bracket , unexpected bracket ,end of compilation }
     PSStack=PSStackNode;

TFormat = record
   line   : integer;
   results: boolean;
   manner : word;
  end;

  TEditForm = class(TForm)

    Memo1: TMemo;
    MainMenu1: TMainMenu;
    MemoPopUp: TPopupMenu;
    FontDialog1: TFontDialog;
    WordWrap1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Center1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    Edit1: TMenuItem;
    SelectAll1: TMenuItem;
    Character1: TMenuItem;
    Font1: TMenuItem;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Close1: TMenuItem;
    N1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N2: TMenuItem;
    Print1: TMenuItem;
    PrintSetup1: TMenuItem;
    N3: TMenuItem;
    Exit1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    SaveFileDialog: TSaveDialog;
    Formula1: TMenuItem;
    Cmpile1: TMenuItem;
    DecompileTree: TMenuItem;
    Conversion1: TMenuItem;
    Conjunctions1: TMenuItem;
    Implications1: TMenuItem;
    Disjunctions1: TMenuItem;
    Literals1: TMenuItem;
    Normalforms1: TMenuItem;
    Conjunctive1: TMenuItem;
    Disjunctive1: TMenuItem;
    MinimalCNF1: TMenuItem;
    MinimalDNF1: TMenuItem;
    Evaluate1: TMenuItem;
    Decision1: TMenuItem;
    Panel1: TPanel;
    RadioGroup1: TRadioGroup;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Format1: TMenuItem;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    Edit2: TEdit;
    Decompile2: TMenuItem;
     procedure DisposeTree;
    procedure CopyTree(var p2:PSTreeNode);
    procedure ConstEval;
    procedure ToImp;
    procedure ToDis;
    procedure ToCon;
    procedure ToConDis;
    procedure ToCNF;
    procedure ToDNF;
    procedure RDisposeTree(var tr:PSTreeNode);
    procedure RCopyTree(var p1,p2:PSTreeNode);
    procedure RConstEval(var tr:PSTreeNode);
    procedure RToImp(var tr:PSTreeNode);
    procedure RToDis(var tr:PSTreeNode);
    procedure RToCon(var tr:PSTreeNode);
    procedure RToConDis(var tr:PSTreeNode);
    procedure RToCNF(var tr:PSTreeNode);
    procedure RToDNF(var tr:PSTreeNode);
    procedure FindOper(var p1:PSTreeNode;var pch:char);
    procedure ChangeOper(p:PStreeNode;ch:char);
    procedure EvlConst1(var p:PSTreeNode);
    procedure Implication(var p:PStreeNode);
    procedure Disjunction(var p:PStreeNode);
    procedure Conjunction(var p:PSTreeNode);
    procedure Distribution(var p1,p2:PSTreeNode);
    procedure CopyNode(var p1,p2 : PSTreeNode);
    procedure ShCopyNode(var p1,p2 : PSTreeNode);
    procedure Exchange(var p1,p2 : PSTreenode);
    procedure SortElm(var tr: PSTreeNode);
    procedure ReduceElm(var t:PSTreeNode);
    procedure IdCom(var p1,p2,master:PSTreeNode);
    procedure Thread;
    procedure UnThread;
    procedure Minimize;
    procedure AbsExt(var p1,p2:PSTreeNode;var o:boolean;pchar:char);


    procedure SelectAll(Sender: TObject);
    procedure SetFont(Sender: TObject);
    procedure SetWordWrap(Sender: TObject);
    procedure AlignClick(Sender: TObject);
    procedure CopyToClipboard(Sender: TObject);
    procedure CutToClipboard(Sender: TObject);
    procedure PasteFromClipboard(Sender: TObject);
    procedure Delete(Sender: TObject);
    procedure SetPopUpItems(Sender: TObject);
    procedure SetEditItems(Sender: TObject);
    procedure Open(const AFilename: string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure New1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);

    procedure XComp;
    procedure XDecomp;
    procedure XDecompTree;

    procedure InsertString(const s:string);
    procedure InsertLine;
    procedure Dive(var node:PSTreeNode);
    procedure DiveTree(TreeLevel:integer; var node:PSTreeNode);
    procedure Decision;
    procedure FormDestroy(Sender: TObject);
    procedure Cmpile1Click(Sender: TObject);
    procedure DecompileTreeClick(Sender: TObject);
    procedure Information1Click(Sender: TObject);
    procedure Disjunctions1Click(Sender: TObject);
    procedure Conjunctions1Click(Sender: TObject);
    procedure Implications1Click(Sender: TObject);
    procedure Literals1Click(Sender: TObject);
    procedure Conjunctive1Click(Sender: TObject);
    procedure Disjunctive1Click(Sender: TObject);
    procedure MinimalCNF1Click(Sender: TObject);
    procedure MinimalDNF1Click(Sender: TObject);
    procedure Evaluate1Click(Sender: TObject);
    procedure Decision1Click(Sender: TObject);
    procedure Format1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Panel1Enter(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure Decompile2Click(Sender: TObject);



  private
    Stree: PSTreeNode;
    Error   : ErrorType;
    FormatP  : TFormat;
    Filename: string;
    FormLen, MatPos : integer;
    FormMatrix : array [1..500, 1..500] of char;
    procedure UpdateMenus;
    procedure SetEditRect;
  end;

implementation

{$R *.DFM}

uses MDIFrm95, SysUtils, Messages, Unit2;
const
  HeapSize = 8 * (1024 div 16);
  BackupExt = '.BAK';
  SWarningText = 'Save Changes to ''%s''?';
  DefaultCaption = 'Untitled';
   ending=#0; {ending character}
  andchar:char='&';
  orchar:char='|';
  TIgnored:set of char=[#1..#32]; {ignored characters}
  TLegal:set of char=['a'..'z','A'..'Z','0','1',ending,'&','|','~','>',
                          '=','(',')' ]; {legal characters}
const InsPos:word=0;
function UsedMem:longint;
var x:THeapStatus;
begin
  x:=GetHeapStatus;
  UsedMem:=x.TotalAllocated;
end;

  function Maxavail:longint;
  var x:THeapStatus;
  begin
    x:=GetHeapStatus;
    MaxAvail:=x.TotalFree;
  end;

  function Memavail:longint;
  var x:THeapStatus;
  begin
    x:=GetHeapStatus;
    MemAvail:=x.TotalFree;
  end;

  procedure TEditForm.InsertLine;
  begin
      Memo1.SetSelTextBuf(#13+#10);
      InsPos:=0;
  end;

  procedure TEditForm.InsertString;
  var i:integer;
  begin
     if InsPos+length(s)>=FormatP.line then
     begin
       InsertLine;
     end;
     Memo1.SelText:=s;
     InsPos:=InsPos+length(s);
  end;

  procedure TEditForm.XComp;{analysis of a formula and generating of a tree
                     by recursion}
                    { Exp1 ::= Exp2  ['=' Exp2];   [] - means iteration
                      Exp2 ::= Exp3  ['>' Exp3];   ' '- means terminal char.
                      Exp3 ::= Exp4  ['|' Exp4];
                      Exp4 ::= ICE   ['&' ICE];
                      ICE ::= '~' ICE | '(' Exp1 ')' | '0' | '1' |
                              | 'A'| .. | 'Z' | 'a' | .. | 'z' ;

                      '0' - false , '1' - true , 'A'..'Z','a'..'z' - atoms ,
                      '~' - negation , '=' - equivalence , '>' - implication ,
                      '|' - disjunction , '&' - conjuction  }
  var pom,garbage:PSStackNode;
      HeapPoint:pointer;
      VPSStack:PSStack;
      ch:char;
      i:integer;
      pos:word;
      editor:PChar;

  procedure StackInit;     {Initilizing of stack}
   begin
    VPSStack:=nil;
   end;



   procedure Put(var chp:char;pr:byte);  {putting of stack node}
    begin
      new(pom);
      pom^.next:=VPSStack;
      VPSStack:=pom;
      new(pom^.node);
      VPSStack^.node^.character:=chp;
      pom^.node^.left:=nil;
      pom^.node^.right:=nil;
      pom^.node^.prior:=pr;
      pom^.node^.neg:=false;

    end;

   function Cut:pointer;     {cutting of stack node}
    begin
     if VPSStack<>nil then
      begin
       Cut:=VPSStack;
       VPSStack:=VPSStack^.next;
      end;
    end;

   procedure SInsert(var p:PSStackNode);  {inserting of existing stack node}
    begin
     p^.next:=VPSStack;
     VPSStack:=p;
    end;
 procedure Action(chr:char;pr:byte);   {putting of operator to stack}
 begin
   Put(chr,pr);
   pom:=Cut;
   pom^.node^.right:=VPSStack^.node;
   garbage:=Cut;
   dispose(garbage);
   pom^.node^.left:=VPSStack^.node;
   garbage:=Cut;
   dispose(garbage);
   SInsert(pom);
 end;

 procedure GetChar;  {reading of character}
  begin
    if Error=OK then
      begin
        repeat
          if pos>=Memo1.SelLength then
            ch:=ending
          else
            begin
              ch:=Editor[pos];
              inc(pos);
            end;
        until not(ch in TIgnored);
        if (not(ch in TLegal))and(error=OK) then Error:=illchar;
      end;
  end;

 procedure Exp1;forward;
 procedure ICE;
 begin
 if error=OK then
  begin
   case ch of
    '~':begin
          Getchar;
          ICE;
          VPSStack^.node^.neg:=not(VPSStack^.node^.neg);
        end;
    'a'..'z','A'..'Z','0'..'1':
        begin
          Put(ch,6);
          Getchar;
        end;
    '(':begin
          Getchar;
          Exp1;
          if (ch<>')')and(error=OK) then Error:=missbra;
          Getchar;
        end
    else Error:=missexp;
    end;
  end;
 end;
 procedure Exp4;
 begin
  if Error=OK then
    begin
      ICE;
      while (ch='&')and(error=OK) do
        begin
         Getchar;
         ICE;
         if error=OK then Action('&',4);
        end;
    end;
 end;

 procedure Exp3;
 begin
  if Error=OK then
    begin
      Exp4;
      while (ch='|')and(error=OK) do
        begin
         Getchar;
         Exp4;

         if error=OK then Action('|',3);

        end;
    end;
 end;

 procedure Exp2;
 begin
  if Error=OK then
    begin
      Exp3;
      while (ch='>')and(error=OK) do
        begin
         Getchar;
         Exp3;
         if error=OK then Action('>',2);
        end;
    end;
 end;

 procedure Exp1;
 begin
  if Error=OK then
    begin
      Exp2;
      while (ch='=')and(error=OK) do
        begin
         Getchar;
         Exp2;
         if error=OK then Action('=',1);
        end;
    end;
 end;

 procedure DisposeStack;
 var pte:PSStackNode;
 begin
   if VPSStack<>nil then
    begin
      pte:=Cut;
      dispose(pte);
    end;
   while VPSStack<>nil do
    begin
     pte:=Cut;
     dispose(pte^.node);
     dispose(pte);
    end;
 end;


 begin
  Editor:=StrAlloc((Memo1.SelLength)+1);
  StackInit;
  Memo1.GetSelTextBuf(Editor,(Memo1.SelLength)+1);
  pos:=0;
  Error:=OK;
  Getchar;
  if Error=OK then Exp1;
  if (ch=')')and(error=OK) then Error:=unexpbra;
  if (ch=ending)and(error=OK) then Error:=endcomp;
  if (ch<>ending)and(error=OK) then Error:=missoper;
  if Error=endcomp then
   begin
      Error:=OK;
      if Stree<>nil then DisposeTree;
      Stree:=VPSStack^.Node;
      dispose(VPSStack);
      Memo1.SelStart:=Memo1.SelStart+Memo1.SelLength;
      Memo1.SelLength:=0;
      InsertLine;
   end
  else
     begin
       if VPSStack<>nil then
         begin
           RDisposeTree(VPSStack^.Node);
         end;
      DisposeStack;
      Memo1.SelStart:=Memo1.SelStart+pos-1;
      Memo1.SelLength:=0;
     end;
 case error of
  illchar: ShowMessage('Illegal character.');
  missoper: ShowMessage('Missing operator.');
  missbra: ShowMessage('Missing right bracket.');
  missexp: ShowMessage('Missing expression.');
  unexpbra: ShowMessage('Unexpected right bracket.');
  mem : ShowMessage('Insuficient memory.');
 end;
 StrDispose(Editor);
 end;      {end of XCOMP}

 procedure TEditForm.Decision;
 begin
   if Stree<>nil then
     begin
       ToDNF;
       Minimize;
       if stop then exit;
       case Stree^.Character of
       '0': begin
              InsertString('This formula is not consistent.');
              InsertLine;
            end;
       '1': begin
              InsertString('This formula is valid.');
              InsertLine;
            end;
       else
         begin
           InsertString('This formula is consistent.Its models '+
           'can be expressed as DNF:');
           InsertLine;
           XDecomp;
         end;
       end;
     end;
 end;

 procedure TEditForm.RDisposeTree;
 begin

       if tr^.prior<>6 then
         begin
           if tr^.left<>nil then RDisposeTree(tr^.left);
           if tr^.right<>nil then RDisposeTree(tr^.right);
         end;
       dispose(tr);
       tr:=nil;
 end;

 procedure TEditForm.DisposeTree;
 begin
   if Stree<>nil then RDisposeTree(Stree);
 end;

 procedure TEditForm.CopyNode;
 begin
   if p1<> nil then
   begin
     new(p2);
     p2^.character:=p1^.character;
     p2^.left:=p1^.left;
     p2^.right:=p1^.right;
     p2^.neg:=p1^.neg;
     p2^.prior:=p1^.prior;
   end;
 end;

 procedure TEditForm.ShCopyNode;
 begin
   if (p1<> nil)and(p2<>nil) then
   begin
     p2^.character:=p1^.character;
     p2^.left:=p1^.left;
     p2^.right:=p1^.right;
     p2^.neg:=p1^.neg;
     p2^.prior:=p1^.prior;
   end;
 end;



 procedure TEditForm.RCopyTree;
 begin

       CopyNode(p1,p2);
       if p1^.prior<>6 then
         begin
           if p1^.left<>nil then RCopyTree(p1^.left,p2^.left);
           if p1^.right<>nil then RCopyTree(p1^.right,p2^.right);
         end;
 end;

 procedure TEditForm.CopyTree;
 begin
   if Stree<>nil then RCopyTree(Stree,p2);
 end;

 procedure TEditForm.FindOper;
 var pompt2,pompt3:PSTreeNode;
   procedure Find1(var p:PSTreeNode);
   begin
     if pompt2=nil then
     begin
       if p^.character=pch then
         begin
           pompt2:=p;p:=pompt3;
         end;
       if p^.prior<>6 then
         begin
           if p^.left<>nil then Find1(p^.left);
           if p^.right<>nil then Find1(p^.right);
         end;
     end;
   end;

    begin
      pompt2:=nil;pompt3:=p1^.right;
      if p1^.left<>nil then Find1(p1^.left);
      if pompt2<>nil then
        begin
          p1^.right:=p1^.left;p1^.left:=pompt2;
        end
      else
        begin
          pompt3:=p1^.left;
          if p1^.right<>nil then Find1(p1^.right);
          if pompt2<>nil then p1^.left:=pompt2;
        end;

    end;


 procedure TEditForm.ChangeOper;
 begin
   if p<>nil then
     begin
       p^.character:=ch;
       case ch of
        '=': p^.prior:=1;
        '>': p^.prior:=2;
        '|': p^.prior:=3;
        '&': p^.prior:=4;
       end;
     end;
  end;



   procedure TEditForm.Dive;
   begin
       if not(stop) then
         begin
         Application.ProcessMessages;
         if (node^.neg=true)and(not(stop)) then
           begin
             InsertString('~');
             if node^.prior<>6 then   {respecting literals with negations}
               begin
                 InsertString('(');
               end;
           end;
         if (node^.prior <> 6)and(not(stop)) then
           if (node^.prior>node^.left^.prior)
               and(not(node^.left^.neg)) then
              begin
                InsertString('(');
                Dive(node^.left);     {respecting priority violation}
                InsertString(')');
              end
           else Dive(node^.left);
         Application.ProcessMessages;
         if not(stop) then InsertString(node^.character);
         if (node^.prior <> 6)and(not(stop)) then
           if ((node^.prior>node^.right^.prior)or
              ((node^.prior=2)and(node^.right^.prior=2)))
               and(not(node^.right^.neg))and(not(stop)) then
              begin
                InsertString('(');
                Dive(node^.right);
                InsertString(')');
              end
           else Dive(node^.right);
         if (node^.prior<>6)and(node^.neg=true)and(not(stop)) then
           begin
             InsertString(')');
           end;
         Application.ProcessMessages;
       end;
  end;

 procedure TEditForm.DiveTree;
   begin
         if (node^.neg=true) then
           begin
             FormMatrix[TreeLevel, MatPos] := '~';
             MatPos := MatPos + 1;
             Inc(TreeLevel);
           end;
         if node^.left <> nil then DiveTree(TreeLevel + 1, node^.left);
         FormMatrix[TreeLevel, MatPos] := node^.character;
         MatPos := MatPos + 1;
         if node^.right <> nil then DiveTree(TreeLevel + 1, node^.right);
  end;

  procedure TEditForm.XDecomp;
  const loc:boolean=false;
   begin
     if Stree<>nil then
      begin
       loc:=Form2.Visible;
       Form2.Visible:=true;
       Dive(Stree);
       InsertLine;
       Form2.Visible:=loc;
      end;
   end;

  procedure TEditForm.XDecompTree;
  const logops = ['&', '|', '>', '=', '~'];
  const loc:boolean=false; var row, col, fill: integer; rowStr, nextrow : string;

   begin
     FillChar(FormMatrix, sizeOf(FormMatrix), ' ');
     MatPos := 1;
     if Stree<>nil then
      begin
       loc:=Form2.Visible;
       Form2.Visible:=true;
       DiveTree(1, Stree);

       for row:= 1 to MatPos do
       begin
         rowstr := '';
         nextrow := '';
         col := 1;
         while col <= MatPos do
         begin
           if FormMatrix[row, col] in logops then
           begin
             rowstr := rowstr + FormMatrix[row, col];
             if FormMatrix[row, col] <> '~' then
             begin
               nextrow[length(nextrow)] := '/';
               fill := col - 2;
               if (FormMatrix[row + 1, col - 1] = ' ') then
               while (FormMatrix[row + 1, fill] = ' ') do
               begin
                 nextrow[fill] := '_';
                 dec(fill);
               end;
             end;
             nextrow := nextrow + ' \';
             inc(col);
             rowstr := rowstr + FormMatrix[row, col];

               fill := col + 1;
               if (FormMatrix[row + 1, col] = ' ') then
               while (FormMatrix[row + 1, fill] = ' ') do
               begin
                 nextrow := nextrow + '_';
                 inc(fill);
                 inc(col);
                 rowstr := rowstr + FormMatrix[row, col];
               end;
             //inc(col);
           end
           else
           begin
             nextrow := nextrow + ' ';
             rowstr := rowstr + FormMatrix[row, col];
           end;
           inc(col);
         end;
           if FormatP.results then rowstr := TrimRight(rowstr);
           if FormatP.results then nextrow := TrimRight(nextrow);
           if TrimRight(rowstr)<>'' then
           begin
             InsertString(rowstr);
             InsertLine;
             InsertString(nextrow);
             InsertLine;
           end;
       end;

       Form2.Visible:=loc;
      end;
   end;


 { Propositional logic laws }



 procedure TEditForm.EvlConst1;
 {procedure for evaluating constants of one node}
 var left:boolean;pchar:char;pneg:boolean;
     pompt1,pompt2:PSTreeNode;
 begin
 if (p<>nil)and(p^.prior<>6) then
 begin
   pompt1:=nil;pompt2:=nil;

   if (p^.left^.character in ['0','1'])and(p^.left<>nil) then
     begin
       pompt1:=p^.right;
       pompt2:=p^.left;
       left:=true;
     end
   else if (p^.right^.character in ['0','1'])and(p^.right<>nil) then
          begin
            pompt1:=p^.left;
            pompt2:=p^.right;
            left:=false;
          end;
   if pompt1<>nil then
     begin
       if pompt2^.neg then
         begin                        {removes negs from constants}
           pompt2^.neg:=false;
           if pompt2^.character='0' then pompt2^.character:='1'
           else pompt2^.character:='0';
         end;
     pchar:=p^.character;
     pneg:=p^.neg;
     dispose(p);
     case pchar of
      '=':begin
            if pompt2^.character='0' then pompt1^.neg:=not(pompt1^.neg);
            p:=pompt1;RdisposeTree(pompt2);
          end;
                { ( A = 1 ) = A
                  ( A = 0 ) = ~A }

      '>':begin
            if pompt2^.character='0' then
              if left then
                 begin
                   p:=pompt2;p^.character:='1';RdisposeTree(pompt1);
                 end
              else begin
                     p:=pompt1;p^.neg:=not(p^.neg);RdisposeTree(pompt2);
                   end
            else
            if pompt2^.character='1' then
              if left then
                begin
                  p:=pompt1;RdisposeTree(pompt2);
                end
              else begin
                     p:=pompt2;RdisposeTree(pompt1);
                   end;
           end;
              { ( A > 1 ) = 1
                ( A > 0 ) = ~A
                ( 1 > A ) = A
                ( 0 > A ) = 1 }

       '|':if pompt2^.character='0' then
                begin
                  p:=pompt1;RdisposeTree(pompt2);
                end
           else begin
                  p:=pompt2;RdisposeTree(pompt1);
                end;
           { ( A | 1 ) = 1
             ( A | 0 ) = A }

        '&':if pompt2^.character='0' then
                begin
                  p:=pompt2;RdisposeTree(pompt1);
                end
           else begin
                  p:=pompt1;RdisposeTree(pompt2);
                end;
             { ( A & 1 ) = A
               ( A & 0 ) = 0 }

      end;

     if pneg then p^.neg := not(p^.neg); 

     if (p^.character='0')and(p^.neg) then
        begin
          p^.character:='1';p^.neg:=false;   {removes negations from const.}
        end
     else if (p^.character='1')and(p^.neg) then
        begin
          p^.character:='0';p^.neg:=false;
        end;
          if FormatP.manner = 0 then
             begin
               InsertString('Constant evaluation:');
               XDecomp;
             end;
    end;
  end;
  end;


 procedure TEditForm.Implication;{converting to >,~}
 var pchar:char;pompt1,pompt2,pompt3:PSTreeNode;
 begin
   if p<>nil then
     begin
       pchar:='>';
       if p^.character = '=' then
         begin
           RCopyTree(p^.left,pompt2);RCopyTree(p^.right,pompt1);
           new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=false;
           pompt3^.right:=p^.right;pompt3^.left:=p^.left;p^.left:=pompt3;
           new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
           pompt3^.left:=pompt1;pompt3^.right:=pompt2;p^.right:=pompt3;
           ChangeOper(p,pchar);p^.neg:=not(p^.neg);
           
           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Equivalence to implication:');
               XDecomp;
             end;
         end
         { ( A = B ) = ~ ( ( A > B ) > ~ ( B > A ) ) }
       else if p^.character = '&' then
         begin
           ChangeOper(p,pchar);p^.neg:=not(p^.neg);
           p^.right^.neg:=not(p^.right^.neg);

           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Conjunction to implication:');
               XDecomp;
             end;
         end
         { ( A & B ) = ~ ( A > ~ B ) }
       else if p^.character = '|' then
         begin
           ChangeOper(p,pchar);p^.left^.neg:=not(p^.left^.neg);

           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Disjunction to implication:');
               XDecomp;
             end;
         end;
         { ( A | B ) =  ~ A > B  }
     end;
  end;

  procedure TEditForm.Disjunction;{converting to |,~}
  var pchar:char;pompt1,pompt2,pompt3:PSTreeNode;
  begin
      if p<>nil then
     begin
       pchar:='|';
       if p^.character = '=' then
         begin
           if p^.neg = true then
           begin
             RCopyTree(p^.left,pompt2);RCopyTree(p^.right,pompt1);
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.right:=p^.right;pompt3^.left:=p^.left;
             pompt3^.left^.neg:=not(pompt3^.left^.neg);p^.left:=pompt3;
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.left:=pompt1;pompt3^.right:=pompt2;
             pompt3^.left^.neg:=not(pompt3^.left^.neg);p^.right:=pompt3;
             ChangeOper(p,pchar);p^.neg:=not(p^.neg);

           end
           else
           begin
             RCopyTree(p^.left,pompt2);RCopyTree(p^.right,pompt1);
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.right:=p^.right;pompt3^.left:=p^.left;p^.left:=pompt3;
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.left:=pompt1;pompt3^.right:=pompt2;
             pompt3^.left^.neg:=not(pompt3^.left^.neg);
             pompt3^.right^.neg:=not(pompt3^.right^.neg);p^.right:=pompt3;
             ChangeOper(p,pchar);
           end;

           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Equivalence to disjunction:');
               XDecomp;
             end;
         end
         { ( A = B ) = ~ ( ~ ( ~ A | B ) | ~ ( B | ~ A ) )
           ( A = B ) =  ~ (  A | B ) | ~ ( ~ B | ~ A )  }
       else if p^.character = '&' then
         begin
           ChangeOper(p,pchar);p^.neg:=not(p^.neg);
           p^.right^.neg:=not(p^.right^.neg);
           p^.left^.neg:=not(p^.left^.neg);
          
           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Conjunction to disjunction:');
               XDecomp;
             end;
         end
         { ( A & B ) = ~ ( ~ A | ~ B ) }
       else if p^.character = '>' then
         begin
           ChangeOper(p,pchar);p^.left^.neg:=not(p^.left^.neg);

           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Implication to disjunction:');
               XDecomp;
             end;
         end;
         { ( A > B ) =  ~ A | B  }
     end;
  end;

  procedure TEditForm.Conjunction;{converting to &,~}
  var pchar:char;pompt1,pompt2,pompt3:PSTreeNode;
  begin
     if p<>nil then
     begin
       pchar:='&';
       if p^.character = '=' then
         begin
           if p^.neg = true then
           begin
             RCopyTree(p^.left,pompt2);RCopyTree(p^.right,pompt1);
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.right:=p^.right;pompt3^.left:=p^.left;
             pompt3^.left^.neg:=not(pompt3^.left^.neg);
             pompt3^.right^.neg:=not(pompt3^.right^.neg);p^.left:=pompt3;
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.left:=pompt1;pompt3^.right:=pompt2;p^.right:=pompt3;
             ChangeOper(p,pchar);p^.neg:=not(p^.neg);
           end
           else
           begin
             RCopyTree(p^.left,pompt2);RCopyTree(p^.right,pompt1);
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.right:=p^.right;pompt3^.left:=p^.left;
             pompt3^.right^.neg:=not(pompt3^.right^.neg);p^.left:=pompt3;
             new(pompt3);ChangeOper(pompt3,pchar);pompt3^.neg:=true;
             pompt3^.left:=pompt1;pompt3^.right:=pompt2;
             pompt3^.right^.neg:=not(pompt3^.right^.neg);
             p^.right:=pompt3;
             ChangeOper(p,pchar);
           end;

           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Equivalence to conjunction:');
               XDecomp;
             end;
         end
         { ( A = B ) = ~ ( ~ ( ~ A & ~ B ) & ~ ( B &  A ) )
           ( A = B ) =  ~ (  A & ~ B ) & ~ ( ~ B &  A )  }
       else if p^.character = '|' then
         begin
           ChangeOper(p,pchar);p^.neg:=not(p^.neg);
           p^.right^.neg:=not(p^.right^.neg);
           p^.left^.neg:=not(p^.left^.neg);
         
           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Disjunction to conjunction:');
               XDecomp;
             end;
         end
         { ( A | B ) = ~ ( ~ A & ~ B ) }
       else if p^.character = '>' then
         begin
           ChangeOper(p,pchar);p^.neg:=not(p^.neg);
           p^.right^.neg:=not(p^.right^.neg);

           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Implication to conjunction:');
               XDecomp;
             end;
         end;
         { ( A > B ) =  ~ ( A & ~ B )  }
     end;
  end;

  procedure TEditForm.Distribution;
  { ( A & B ) | C = ( A | C ) & ( B | C )
    ( A | B ) & C = ( A & C ) | ( B & C ) }
    var pchar,pchar2:char;pompt1,pompt2,pompt3:PSTreeNode;
  begin
    if (p1<>nil) and (p2<>nil) and (p1^.character in ['&','|'] )
      and (p2^.character in ['&','|']) then
      begin
        RCopyTree(p2^.right,pompt1);
        pchar:=p1^.character;
        pchar2:=p2^.character;
        Changeoper(p2,pchar);Changeoper(p1,pchar2);pompt2:=p1^.right;
        p1^.right:=pompt1;new(pompt3);Changeoper(pompt3,pchar2);
        pompt3^.neg:=false;pompt3^.left:=pompt2;
        pompt3^.right:=p2^.right;p2^.right:=pompt3;

           if FormatP.manner <= 2  then
             begin
               if FormatP.manner <= 1 then
                   InsertString('Distribution:');
               XDecomp;
             end;

      end;
   end;

   procedure TEditForm.IdCom;
   begin
     if (p1<>nil)and(p2<>nil)and(p1^.prior=6)and(p2^.prior=6)and
        (not(p1^.character in ['0','1']))and
        (not(p2^.character in ['0','1'])) then
       begin
         if p1^.character=p2^.character then
           begin
             if p1^.neg=p2^.neg then
               begin
                 case master^.character of
                 '&':p1^.character:='1';
                 '|':p1^.character:='0';
                 end;
                 p1^.neg:=false;
            
                  if FormatP.manner <= 2  then
                   begin
                    if FormatP.manner <= 1 then
                     InsertString('Idempotention:');
                    XDecomp;
                   end;
               end
             else
             begin
                 case master^.character of
                  '&':p1^.character:='0';
                  '|':p1^.character:='1';
                  end;
                 p1^.neg:=false;
                
                 if FormatP.manner <= 2  then
                  begin
                    if FormatP.manner <= 1 then
                     InsertString('Complementarity:');
                    XDecomp;
                 end;
             end;
           end;
       end;
   end;

   procedure TEditForm.AbsExt;
   var OK,left,right,cst:boolean;pom1,pom2,pom3,pom4,pt:PSTreeNode;
     procedure Find(var tr:PSTreeNode);
     begin
       if (tr^.prior<>6) then
         begin
           Find(tr^.left);
           Find(tr^.right);
         end
       else begin
              if not(tr^.character in ['0','1']) then
              if pt=nil then pt:=tr;
              if tr^.character in ['0','1'] then cst:=true;
            end;
     end;

   { absorption,negation absorption and extension law
     on NF elements }
   begin
     pom1:=p1;pom2:=p2;pom3:=nil;pom4:=nil;Ok:=true;left:=false;
     right:=false;cst:=false;
     pt:=nil;Find(p1);pom1:=pt;
     if cst=false then
       begin
         pt:=nil;Find(p2);pom2:=pt;
       end;
     if (pom1<>nil)and(pom2<>nil)and(cst=false) then
     begin
     repeat

       if ((pom1<>nil)and(pom2<>nil)and(pom1^.character>pom2^.character))or
          ((pom1=nil)and(pom2<>nil)) then
         begin
           right:=true;
           if pom2<>nil then pom2:=pom2^.right;
         end;
       if ((pom1<>nil)and(pom2<>nil)and(pom1^.character<pom2^.character))or
          ((pom1<>nil)and(pom2=nil)) then
         begin
           left:=true;
           if pom1<>nil then pom1:=pom1^.right;
         end;
       if (pom1<>nil)and(pom2<>nil)and
          (pom1^.character=pom2^.character)and(pom1^.neg<>pom2^.neg) then
         if (pom3<>nil)and(pom4<>nil) then OK:=false
         else
           begin
             pom3:=pom1;
             pom4:=pom2;
           end;
       if (pom1<>nil)and(pom2<>nil)and
          (pom1^.character=pom2^.character) then
           begin
             if (pom1<>nil) then pom1:=pom1^.right;
             if (pom2<>nil) then pom2:=pom2^.right;
           end;
       until (OK=false)or((pom1=nil)and(pom2=nil));
       pt:=nil;Find(p1);pom1:=pt;
       pt:=nil;Find(p2);pom2:=pt;
       if (not((left)and(right)))and(OK) then
         begin
           if (left=false)and(right=false) then
             if pom3=nil then       {two same elms}
              begin
                case pchar of
                 '&':pom1^.character:='1';
                 '|':pom1^.character:='0';
                end;
                pom1^.neg:=false;

                 if FormatP.manner <= 2  then
                  begin
                    if FormatP.manner <= 1 then
                     InsertString('Total absorption:');
                    XDecomp;
                  end;
              end
           else                   {extension law}
             begin
               case pchar of
               '&': begin
                      pom1^.character:='1';
                      pom4^.character:='0';
                    end;
               '|': begin
                      pom1^.character:='0';
                      pom4^.character:='1';
                   end;
               end;
               pom1^.neg:=false;pom4^.neg:=false;

                 if FormatP.manner <= 2  then
                  begin
                    if FormatP.manner <= 1 then
                     InsertString('Extension:');
                    XDecomp;
                  end;
             end;
         if left then
           if pom3=nil then
             begin
               case pchar of                {absorption}
               '&': pom1^.character:='1';
               '|': pom1^.character:='0';
               end;
               pom1^.neg:=false;

                 if FormatP.manner <= 2  then
                  begin
                    if FormatP.manner <= 1 then
                     InsertString('Absorption:');
                    XDecomp;
                  end;
             end
           else
             begin
               case pchar of                {negation absorption}
               '&': pom3^.character:='0';
               '|': pom3^.character:='1';
               end;
               pom3^.neg:=false;

                 if FormatP.manner <= 2  then
                  begin
                    if FormatP.manner <= 1 then
                     InsertString('Absorption of negation:');
                    XDecomp;
                  end;
             end;
         if right then
           if pom4=nil then
             begin
               case pchar of                {absorption}
               '&': pom2^.character:='1';
               '|': pom2^.character:='0';
               end;
               pom2^.neg:=false;

                 if FormatP.manner <= 2  then
                  begin
                    if FormatP.manner <= 1 then
                     InsertString('Absorption:');
                    XDecomp;
                  end;
             end
           else
             begin
               case pchar of                {negation absorption}
               '&': pom4^.character:='0';
               '|': pom4^.character:='1';
               end;
               pom4^.neg:=false;

                 if FormatP.manner <= 2  then
                  begin
                    if FormatP.manner <= 1 then
                     InsertString('Absorption of negation:');
                    XDecomp;
                  end;
             end;
         Thread;
         o:=true;
     end;
   end;
   end;


  {user procedures for manipulations}

  procedure TEditForm.RConstEval;
    begin
      if  (tr^.prior <> 6)and(not(stop)) then
        begin
          Application.ProcessMessages;

          RConstEval(tr^.left);

          RConstEval(tr^.right);
          Application.ProcessMessages;

          EvlConst1(tr);
        end;
    end;
  procedure TEditForm.ConstEval;
  begin
    if Stree<>nil then
      begin
        RConstEval(Stree);
      end;
  end;


  procedure TEditForm.RToImp;
  begin

    if  (tr^.prior <> 6)and(not(stop)) then
      begin
        Application.ProcessMessages;

        Implication(tr);

        RToImp(tr^.left);

        RToImp(tr^.right);
      end;
  end;

  procedure TEditForm.ToImp;
  begin
    if Stree<>nil then
      begin
        RToImp(Stree);

                 if FormatP.manner = 3  then
                  begin
                    InsertString('Result - Global conversion to implication:');
                    XDecomp;
                  end;
      end;
  end;

  procedure TEditForm.RToDis;
  begin

    if (tr^.prior <> 6)and(not(stop)) then
      begin
        Application.ProcessMessages;

        Disjunction(tr);

        RToDis(tr^.left);

        RToDis(tr^.right);
      end;
  end;

  procedure TEditForm.ToDis;
  begin
    if Stree<>nil then
      begin
        RToDis(Stree);

                 if FormatP.manner = 3  then
                  begin
                    InsertString('Result - Global conversion to disjunctions:');
                    XDecomp;
                  end;
      end;
  end;

  procedure TEditForm.RToCon;
  begin

    if (tr^.prior<>6)and(not(stop)) then
      begin
        Application.ProcessMessages;

        Conjunction(tr);

        RToCon(tr^.left);

        RToCon(tr^.right);
      end;
  end;

  procedure TEditForm.ToCon;
  begin
    if Stree<>nil then
      begin
        RToCon(Stree);

                 if FormatP.manner = 3  then
                  begin
                    InsertString('Result - Global conversion to conjunctions:');
                    XDecomp;
                  end;
      end;
  end;

  procedure TEditForm.RToConDis;
  begin

    if (tr^.prior<>6)and(not(stop)) then
      begin
        Application.ProcessMessages;
        if (tr^.neg)or(not(tr^.character in ['&','|'])) then Conjunction(tr);

        if (tr<>nil)and(tr^.neg) then Disjunction(tr);

        RToConDis(tr^.left);

        RToConDis(tr^.right);
      end;
  end;

  procedure TEditForm.ToConDis;
  begin
    if Stree<>nil then
     begin
       RToConDis(Stree);

                 if FormatP.manner = 3  then
                  begin
                    InsertString('Result - Global conversion to literal form:');
                    XDecomp;
                  end;
     end;
  end;

  procedure TEditForm.ReduceElm;
  var pompt1:PSTreeNode;
  procedure RReduceElm(var tr:PSTreeNode);

  begin
  if stop then exit;
  if (tr^.character=t^.character)or(tr^.prior=6) then
  begin
    if (tr^.prior<>6) then
      begin
        RReduceElm(tr^.left);
        RReduceElm(tr^.right);
      end
    else
      begin
        if (pompt1<>nil) then IdCom(pompt1,tr,t);
        pompt1:=tr;
      end;
  end;
  end;
  begin
    pompt1:=nil;
    RReduceElm(t);
  end;

  procedure TEditForm.Exchange;
  var pom:PSTreeNode;
  begin
    new(pom);
    ShCopyNode(p1,pom);
    ShCopyNode(p2,p1);
    ShCopyNode(pom,p2);
    dispose(pom);
  end;


  procedure TEditForm.SortElm;
    var op:boolean;var pchar:char;pompt1:PSTreeNode;
    procedure Bubble(var t:PSTreeNode);
      begin
        if (t^.character=pchar)or(t^.prior=6) then
        begin
          if t^.prior<>6 then
            begin
              Bubble(t^.left);
              Bubble(t^.right);
            end
          else
          begin
            if (pompt1<>nil)and(pompt1^.character>t^.character) then
              begin
                Exchange(pompt1,t);
                op:=true;
              end;
            pompt1:=t;
          end;
        end;
      end;

    begin
      op:=true;
      pchar:=tr^.character;
      while op do
       begin
        op:=false;
        pompt1:=nil;
        Bubble(tr);
       end;
    end;

  procedure TEditForm.RToCNF;
  begin

    if  (tr^.prior<>6)and(not(stop)) then
      begin
        if tr^.character<>andchar then
          begin
            FindOper(tr,andchar);
            if tr^.left^.character<>andchar then
               begin

                 SortElm(tr);
                 ReduceElm(tr);
               end;
            if tr^.left^.character=andchar then Distribution(tr^.left,tr);
          end;

        RToCNF(tr^.left);

        RToCNF(tr^.right);

        if (tr^.character=andchar) then
         begin

           RConstEval(tr^.left);

           RConstEval(tr^.right);
         end;
         Application.ProcessMessages;
      end;

  end;


  procedure TEditForm.ToCNF;
  var i:integer;
  begin

    if Stree<>nil then
    begin
      ToConDis;
      ConstEval;
      RToCNF(Stree);
      if stop then
        begin
          DisposeTree;
          Stree:=nil;
        end
      else
      begin
        SortElm(Stree);
        ReduceElm(STree);
        ConstEval;

                 if FormatP.manner = 3  then
                  begin
                    InsertString('Result - Conversion to CNF:');
                    XDecomp;
                  end;
       end;
    end;
  end;

  procedure TEditForm.RToDNF;
  begin

    if (tr^.prior<>6)and(not(stop)) then
      begin
        if tr^.character<>orchar then
          begin

            FindOper(tr,orchar);
            if tr^.left^.character<>orchar then
               begin

                 SortElm(tr);
                 ReduceElm(tr);
               end;

            if tr^.left^.character=orchar then Distribution(tr^.left,tr);

          end;

        RToDNF(tr^.left);

        RToDNF(tr^.right);

        if (tr^.character=orchar) then
         begin
           RConstEval(tr^.left);
           RConstEval(tr^.right);

         end;
          Application.ProcessMessages;
      end;
  end;

  procedure TEditForm.ToDNF;
  var i:integer;
  begin
    if Stree<>nil then
     begin
      ToConDis;
      ConstEval;
      RToDNF(Stree);
      if stop then
        begin
          DisposeTree;
          Stree:=nil;
        end
      else
      begin
        SortElm(Stree);
        ReduceElm(STree);
        ConstEval;

                 if FormatP.manner = 3  then
                  begin
                    InsertString('Result - Conversion to DNF:');
                    XDecomp;
                  end;
       end;
     end;
  end;

  procedure TEditForm.Thread;
  var pompt1:PSTreeNode;pchar:char;
    procedure RThread(var tr:PSTreeNode);
    begin
      if tr^.prior<>6 then
        begin
          RThread(tr^.left);
          RThread(tr^.right);
        end
      else if not(tr^.character in ['1','0']) then
        begin
          if pompt1<>nil then
            begin
              pompt1^.right:=tr;tr^.left:=pompt1;
            end;
          pompt1:=tr;
        end;
    end;

    procedure RDive(var t:PSTreeNode);
    begin
      if (t^.prior<>6) then
        if t^.character=pchar then
          begin
            RDive(t^.left);
            RDive(t^.right);
          end
        else if not(t^.character in ['0','1']) then
        begin
          pompt1:=nil;
          RThread(t);
        end;
    end;

  begin
    if not(stop) then
    begin
    pompt1:=nil;
    pchar:=Stree^.character;
    RDive(Stree);
    end;
  end;

  procedure TEditForm.UnThread;
    procedure RUnThread(var tr:PSTreeNode);
    begin
      if tr^.prior<>6 then
        begin
          RUnThread(tr^.left);
          RUnThread(tr^.right);
        end
      else
        begin
          tr^.right:=nil;tr^.left:=nil;
        end;
    end;
  begin
    RUnThread(STree);
  end;

  procedure TEditForm.Minimize;
  var pompt1,pompt2:PSTreeNode;pchar:char;op:boolean;

    procedure RRunner(var t:PSTreeNode);
      begin
       
        if (t^.prior<>6)and(t^.character=pchar) then
          begin
            RRunner(t^.left);
            RRunner(t^.right);
          end;
        if (t^.character<>pchar)and(not(t^.character in ['0','1'])) then
        begin
         if pompt1=t then pompt1:=nil;
         if pompt1<>nil then
          begin
            AbsExt(t,pompt1,op,pchar);
            Application.ProcessMessages;
          end;
        end;
      end;

    procedure RMinimize(var tr:PSTreeNode);
      begin
      if not(stop) then
      begin
        if (tr^.prior<>6)and(tr^.character=pchar) then
          begin
            RMinimize(tr^.left);
            RMinimize(tr^.right);

          end;
        if (tr^.character<>pchar)and(not(tr^.character in ['0','1'])) then
          begin
            pompt1:=tr;RRunner(STree);
          end;
      end;
    end;

   begin
     if (STree<>nil)and(Stree^.prior<>6) then
       begin
         op:=true;
         Thread;
         while op do
           begin
             pchar:=STree^.character;
             op:=false;
             pompt1:=nil;
             RMinimize(STree);
             ConstEval;
             UnThread;
             Thread;
           end;
         UnThread;
         if STree^.prior<>6 then
               begin
                 SortElm(STree);
                 ReduceElm(STree);
                 ConstEval;
               end;
         if Stop then
            begin
               DisposeTree;
               STree:=nil;
            end;

                 if FormatP.manner = 3  then
                  begin
                    InsertString('Result - Reduction to minimal NF:');
                    XDecomp;
                  end;
       end;
    end;






procedure TEditForm.SelectAll(Sender: TObject);
begin
  Memo1.SelectAll;
end;

procedure TEditForm.SetFont(Sender: TObject);
begin
  FontDialog1.Font := Memo1.Font;
  if FontDialog1.Execute then
    Memo1.Font := FontDialog1.Font;
  SetEditRect;
end;

procedure TEditForm.SetWordWrap(Sender: TObject);
begin
  with Memo1 do
  begin
    WordWrap := not WordWrap;
    if WordWrap then
      ScrollBars := ssVertical else
      ScrollBars := ssBoth;
    WordWrap1.Checked := WordWrap;
  end;
  SetEditRect;
end;

procedure TEditForm.AlignClick(Sender: TObject);
begin
  Left1.Checked := False;
  Right1.Checked := False;
  Center1.Checked := False;
  with Sender as TMenuItem do Checked := True;
  with Memo1 do
    if Left1.Checked then
      Alignment := taLeftJustify
    else if Right1.Checked then
      Alignment := taRightJustify
    else if Center1.Checked then
      Alignment := taCenter;
end;

procedure TEditForm.CopyToClipboard(Sender: TObject);
begin
  Memo1.CopyToClipboard;
end;

procedure TEditForm.CutToClipboard(Sender: TObject);
begin
  Memo1.CutToClipboard;
end;

procedure TEditForm.PasteFromClipboard(Sender: TObject);
begin
  Memo1.PasteFromClipboard;
end;

procedure TEditForm.Delete(Sender: TObject);
begin
  Memo1.ClearSelection;
end;

procedure TEditForm.UpdateMenus;
var
  HasSelection: Boolean;
begin
  Paste1.Enabled := Clipboard.HasFormat(CF_TEXT);
  Paste2.Enabled := Clipboard.HasFormat(CF_TEXT);
  HasSelection := Memo1.SelLength <> 0;
  Cut1.Enabled := HasSelection;
  Copy1.Enabled := HasSelection;
  Delete1.Enabled := HasSelection;
  Cut2.Enabled := HasSelection;
  Copy2.Enabled := HasSelection;
end;

procedure TEditForm.SetEditItems(Sender: TObject);
begin
  UpdateMenus;
end;

procedure TEditForm.SetPopUpItems(Sender: TObject);
begin
  UpdateMenus;
end;

procedure TEditForm.Open(const AFilename: string);
begin
  Filename := AFilename;
  Memo1.Lines.LoadFromFile(FileName);
  Memo1.SelStart := 0;
  Caption := ExtractFileName(FileName);
  Memo1.Modified := False;
end;

procedure TEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TEditForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  DialogValue: Integer;
  FName: string;
begin
  if Memo1.Modified then
  begin
    FName := Caption;
    DialogValue := MessageDlg(Format(SWarningText, [FName]), mtConfirmation,
      [mbYes, mbNo, mbCancel], 0);
    case DialogValue of
      id_Yes: Save1Click(Self);
      id_Cancel: CanClose := False;
    end;
  end;
end;

procedure TEditForm.New1Click(Sender: TObject);
begin
  FrameForm.NewChild(Sender);
end;

procedure TEditForm.Open1Click(Sender: TObject);
begin
  FrameForm.OpenChild(Sender);
end;

procedure TEditForm.Exit1Click(Sender: TObject);
begin
  FrameForm.Exit1Click(Sender);
end;

procedure TEditForm.Close1Click(Sender: TObject);
begin
  Close;
end;

{ the printing performed in this example either prints the entire buffer,   }
{ or...if a section of text is selected, will print the selected text;      }
{ in addition, the first line of selected text will be printed left         }
{ justified; no attempt is made to make the lines appear as they do on the  }
{ monitor.  WYSIWYG printing is beyond the scope of this demo program.      }
{ The following features of printing are not demonstrated:                  }
{     Multiple Copies                                                       }
{     Collating Multiple Copies                                             }
{     Page Ranges                                                           }
{     Multiple Fonts, Word Wrapping, etc.                                   }
procedure TEditForm.Print1Click(Sender: TObject);
var
  Line: Integer;
  PrintText: System.Text;
begin
  if PrintDialog1.Execute then
  begin
    AssignPrn(PrintText);
    Rewrite(PrintText);
    Printer.Canvas.Font := Memo1.Font;
    for Line := 0 to Memo1.Lines.Count - 1 do
      Writeln(PrintText, Memo1.Lines[Line]);
    System.Close(PrintText);
  end;
end;

procedure TEditForm.PrintSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog1.Execute;
end;

procedure TEditForm.SaveAs1Click(Sender: TObject);
begin
  SaveFileDialog.Filename := Filename;
  if SaveFileDialog.Execute then
  begin
    Filename := SaveFileDialog.Filename;
    Caption := ExtractFileName(Filename);
    Save1Click(Sender);
  end;
end;

procedure TEditForm.Save1Click(Sender: TObject);

  procedure CreateBackup(const Filename: string);
  var
    BackupFilename: string;
  begin
    BackupFilename := ChangeFileExt(Filename, BackupExt);
    DeleteFile(BackupFilename);
    RenameFile(Filename, BackupFilename);
  end;

  function IsReadOnly(const Filename: string): Boolean;
  begin
    Result := false;
    Result := (Boolean(FileGetAttr(Filename) and faReadOnly))
           and(FileGetAttr(Filename)<>-1);
    if Result then MessageDlg(Format('%s is read only.',
      [ExtractFilename(Filename)]), mtWarning, [mbOK], 0);
  end;

begin
  if (Filename = '') or IsReadOnly(Filename) then
    SaveAs1Click(Sender)
  else
  begin
    CreateBackup(Filename);
    Memo1.Lines.SaveToFile(Filename);
    Memo1.Modified := False;
  end;
end;

procedure TEditForm.SetEditRect;
var
  R: TRect;
begin
  R := Memo1.ClientRect;
  InflateRect(R, -3, -2);
  SendMessage(Memo1.Handle, EM_SETRECT, 0, Longint(@R));
end;

procedure TEditForm.FormCreate(Sender: TObject);
begin
  SetEditRect;
    Stree:=nil;
    FormatP.line:=77;
    FormatP.results:=true;
    FormatP.manner:=4;
    Stop:=false;
end;

procedure TEditForm.FormResize(Sender: TObject);
begin
  SetEditRect;
end;

procedure TEditForm.FormDestroy(Sender: TObject);
begin
   DisposeTree;
end;

procedure TEditForm.Cmpile1Click(Sender: TObject);
begin
   if Memo1.SelLength>0 then XComp
                     else ShowMessage('No selected text.');
end;

procedure TEditForm.DecompileTreeClick(Sender: TObject);
var FormLen : integer;
begin
   if not(FormatP.results) then Memo1.Visible := false;
   if Memo1.SelLength>0 then
   begin
     FormLen := Memo1.SelLength;
     XComp;

     XDecompTree;
   end
   else ShowMessage('No selected text.');
   Memo1.Visible := true;
end;

procedure TEditForm.Information1Click(Sender: TObject);
begin
   ShowMessage('Available memory:'+inttostr(MemAvail)+' bytes.');
end;

procedure TEditForm.Disjunctions1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if (Stree<>nil) then
    begin
      ToDis;
      if stop then  Stop:=false;
      if FormatP.results then XDecomp;
    end;
  Memo1.Visible := true;
end;

procedure TEditForm.Conjunctions1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      ToCon;
      if stop then  Stop:=false;
      if FormatP.results then XDecomp;
    end;
  Memo1.Visible := true;
end;

procedure TEditForm.Implications1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      ToImp;
      if stop then  Stop:=false;
      if FormatP.results then XDecomp;
    end;
  Memo1.Visible := true;
end;

procedure TEditForm.Literals1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      ToConDis;
      if stop then  Stop:=false;
      if FormatP.results then XDecomp;
    end;
  Memo1.Visible := true;
end;

procedure TEditForm.Conjunctive1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      Form2.Visible:=true;
      ToCNF;
      if stop then  Stop:=false;
      Form2.Visible:=false;
      if FormatP.results then XDecomp;
    end;
    Memo1.Visible := true;
end;

procedure TEditForm.Disjunctive1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      Form2.Visible:=true;
      ToDNF;
      if stop then stop:=false;
      Form2.Visible:=false;
      if FormatP.results then XDecomp;
    end;
    Memo1.Visible := true;
end;

procedure TEditForm.MinimalCNF1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      Form2.Visible:=true;
      ToCNF;
      Minimize;
      if stop then stop:=false;
      if FormatP.results then XDecomp;
      Form2.Visible:=false;
    end;
    Memo1.Visible := true;
end;

procedure TEditForm.MinimalDNF1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      Form2.Visible:=true;
      ToDNF;
      Minimize;
      if stop then stop:=false;
      if FormatP.results then XDecomp;
      Form2.Visible:=false;
    end;
    Memo1.Visible := true;
end;

procedure TEditForm.Evaluate1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      Form2.Visible:=true;
      ConstEval;
      if stop then  Stop:=false;
      if FormatP.results then XDecomp;
      if stop then stop:=false;
        Form2.Visible:=false;
    end;
    Memo1.Visible := true;
end;

procedure TEditForm.Decision1Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  if Memo1.SelLength<>0 then
    begin
      XComp;
      if Error<>OK then Exit;
    end;
  if Stree<>nil then
    begin
      Form2.Visible:=true;
      Decision;
      if stop then  Stop:=false;
      Form2.Visible:=false;
    end;
  Memo1.Visible := true;
end;

procedure TEditForm.Format1Click(Sender: TObject);
var pom:string;
begin
  Panel1.Visible:=true;
  Panel1.SetFocus;
end;

procedure TEditForm.BitBtn1Click(Sender: TObject);
var pom:string;
    i:integer;
begin
repeat
  pom:=Edit2.Text;
  val(pom,FormatP.line,i);
  FormatP.results:=CheckBox1.Checked;
  FormatP.manner:=RadioGroup1.ItemIndex;
  if (FormatP.line <= 20)or(FormatP.line>250)
   then
    begin
     ShowMessage('Current line range between 21 and 250.'+#13+#10+
           'Default value 79 is used.');
     FormatP.line:=79;
    end;
 until (FormatP.line>20)and(FormatP.line<=250);
   Panel1.Visible:=False;
end;



procedure TEditForm.Panel1Enter(Sender: TObject);
var pom:string;
begin
 str(FormatP.line,pom);
 Edit2.Text:=pom;
 CheckBox1.Checked:=FormatP.results;
 RadioGroup1.ItemIndex:=FormatP.manner;
end;


procedure TEditForm.StatusBar1Click(Sender: TObject);
begin
   showmessage('Clicked.');
end;


procedure TEditForm.Decompile2Click(Sender: TObject);
begin
  if not(FormatP.results) then Memo1.Visible := false;
  XDecomp;
  Memo1.Visible := true;
end;

end.


